
/* A Bison parser, made by GNU Bison 2.4.1.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C
   
      Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006
   Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.4.1"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Copy the first part of user declarations.  */

/* Line 189 of yacc.c  */
#line 1 "parser.y"

/*-------------------------------------------------------------------------
 * parser.y
 *
 *	The slonik command language grammar
 *
 *	Copyright (c) 2003-2009, PostgreSQL Global Development Group
 *	Author: Jan Wieck, Afilias USA INC.
 *
 *	
 *-------------------------------------------------------------------------
 */

#include "types.h"
#include "libpq-fe.h"
#include "slonik.h"
#include "scan.h"


/*
 * Common per statement possible option strcture
 */
typedef struct statement_option {
	option_code	opt_code;
	int			lineno;
	int			ival;
	char	   *str;
} statement_option;
#define	STMT_OPTION_INT(_code,_dfl)		{_code, -1, _dfl, NULL}
#define	STMT_OPTION_STR(_code,_dfl)		{_code, -1, -1, _dfl}
#define	STMT_OPTION_YN(_code,_dfl)		{_code, -1, _dfl, NULL}
#define STMT_OPTION_END					{END_OF_OPTIONS, -1, -1, NULL}


/*
 * Global data
 */
char   *current_file = "<stdin>";
#ifdef DEBUG
int yydebug=1;
#endif
/*
 * Local functions
 */
static int	assign_options(statement_option *so, option_list *ol);





/* Line 189 of yacc.c  */
#line 124 "y.tab.c"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     K_ADD = 258,
     K_ADMIN = 259,
     K_ALL = 260,
     K_BACKUP = 261,
     K_CLIENT = 262,
     K_CLONE = 263,
     K_CLUSTER = 264,
     K_CLUSTERNAME = 265,
     K_COMMENT = 266,
     K_CONFIRMED = 267,
     K_CONFIG = 268,
     K_CONNINFO = 269,
     K_CONNRETRY = 270,
     K_COPY = 271,
     K_CREATE = 272,
     K_DROP = 273,
     K_ECHO = 274,
     K_DATE = 275,
     K_DFORMAT = 276,
     K_ERROR = 277,
     K_EVENT = 278,
     K_EXECUTE = 279,
     K_EXIT = 280,
     K_FAILOVER = 281,
     K_FALSE = 282,
     K_FILENAME = 283,
     K_FINISH = 284,
     K_FOR = 285,
     K_FORWARD = 286,
     K_FULL = 287,
     K_FUNCTIONS = 288,
     K_ID = 289,
     K_INIT = 290,
     K_KEY = 291,
     K_LISTEN = 292,
     K_LOCK = 293,
     K_LOG = 294,
     K_MERGE = 295,
     K_MOVE = 296,
     K_NAME = 297,
     K_NEW = 298,
     K_NO = 299,
     K_NODE = 300,
     K_OFF = 301,
     K_OLD = 302,
     K_OMIT = 303,
     K_ON = 304,
     K_ONLY = 305,
     K_ORIGIN = 306,
     K_PATH = 307,
     K_PREPARE = 308,
     K_PROVIDER = 309,
     K_QUALIFIED = 310,
     K_RECEIVER = 311,
     K_REPAIR = 312,
     K_RESTART = 313,
     K_RESUBSCRIBE = 314,
     K_SCRIPT = 315,
     K_SECONDS = 316,
     K_SEQUENCE = 317,
     K_SERVER = 318,
     K_SET = 319,
     K_STORE = 320,
     K_SUBSCRIBE = 321,
     K_SUCCESS = 322,
     K_SWITCH = 323,
     K_TABLE = 324,
     K_TABLES = 325,
     K_SEQUENCES = 326,
     K_TIMEOUT = 327,
     K_TRUE = 328,
     K_TRY = 329,
     K_UNINSTALL = 330,
     K_UNLOCK = 331,
     K_UNSUBSCRIBE = 332,
     K_UPDATE = 333,
     K_YES = 334,
     K_WAIT = 335,
     K_SYNC = 336,
     K_SLEEP = 337,
     T_IDENT = 338,
     T_LITERAL = 339,
     T_NUMBER = 340
   };
#endif
/* Tokens.  */
#define K_ADD 258
#define K_ADMIN 259
#define K_ALL 260
#define K_BACKUP 261
#define K_CLIENT 262
#define K_CLONE 263
#define K_CLUSTER 264
#define K_CLUSTERNAME 265
#define K_COMMENT 266
#define K_CONFIRMED 267
#define K_CONFIG 268
#define K_CONNINFO 269
#define K_CONNRETRY 270
#define K_COPY 271
#define K_CREATE 272
#define K_DROP 273
#define K_ECHO 274
#define K_DATE 275
#define K_DFORMAT 276
#define K_ERROR 277
#define K_EVENT 278
#define K_EXECUTE 279
#define K_EXIT 280
#define K_FAILOVER 281
#define K_FALSE 282
#define K_FILENAME 283
#define K_FINISH 284
#define K_FOR 285
#define K_FORWARD 286
#define K_FULL 287
#define K_FUNCTIONS 288
#define K_ID 289
#define K_INIT 290
#define K_KEY 291
#define K_LISTEN 292
#define K_LOCK 293
#define K_LOG 294
#define K_MERGE 295
#define K_MOVE 296
#define K_NAME 297
#define K_NEW 298
#define K_NO 299
#define K_NODE 300
#define K_OFF 301
#define K_OLD 302
#define K_OMIT 303
#define K_ON 304
#define K_ONLY 305
#define K_ORIGIN 306
#define K_PATH 307
#define K_PREPARE 308
#define K_PROVIDER 309
#define K_QUALIFIED 310
#define K_RECEIVER 311
#define K_REPAIR 312
#define K_RESTART 313
#define K_RESUBSCRIBE 314
#define K_SCRIPT 315
#define K_SECONDS 316
#define K_SEQUENCE 317
#define K_SERVER 318
#define K_SET 319
#define K_STORE 320
#define K_SUBSCRIBE 321
#define K_SUCCESS 322
#define K_SWITCH 323
#define K_TABLE 324
#define K_TABLES 325
#define K_SEQUENCES 326
#define K_TIMEOUT 327
#define K_TRUE 328
#define K_TRY 329
#define K_UNINSTALL 330
#define K_UNLOCK 331
#define K_UNSUBSCRIBE 332
#define K_UPDATE 333
#define K_YES 334
#define K_WAIT 335
#define K_SYNC 336
#define K_SLEEP 337
#define T_IDENT 338
#define T_LITERAL 339
#define T_NUMBER 340




#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 214 of yacc.c  */
#line 54 "parser.y"

	int32		ival;
	char		*str;
	option_list	*opt_list;
	SlonikAdmInfo	*adm_info;
	SlonikStmt	*statement;
	failed_node_entry * failed_node_entry;



/* Line 214 of yacc.c  */
#line 341 "y.tab.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif


/* Copy the second part of user declarations.  */


/* Line 264 of yacc.c  */
#line 353 "y.tab.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  4
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   447

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  94
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  66
/* YYNRULES -- Number of rules.  */
#define YYNRULES  157
/* YYNRULES -- Number of states.  */
#define YYNSTATES  346

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   340

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      91,    92,     2,     2,    93,    90,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,    87,
       2,    86,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    88,     2,    89,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     7,    14,    16,    19,    28,    30,    33,
      35,    37,    39,    46,    54,    62,    69,    75,    81,    87,
      89,    92,    94,    96,    98,   100,   102,   104,   106,   108,
     110,   112,   114,   116,   118,   120,   122,   124,   126,   128,
     130,   132,   134,   136,   138,   140,   142,   144,   146,   148,
     150,   152,   154,   156,   158,   160,   163,   165,   167,   169,
     171,   176,   180,   185,   191,   196,   198,   201,   204,   209,
     214,   219,   226,   230,   236,   244,   249,   254,   259,   264,
     269,   274,   279,   284,   289,   294,   300,   306,   312,   318,
     324,   330,   335,   340,   345,   350,   355,   360,   365,   370,
     376,   382,   387,   391,   395,   397,   402,   404,   408,   412,
     416,   421,   426,   430,   434,   438,   443,   448,   453,   458,
     462,   466,   470,   474,   478,   482,   487,   492,   497,   502,
     508,   512,   516,   520,   524,   528,   532,   537,   541,   547,
     553,   557,   561,   565,   570,   572,   574,   576,   578,   580,
     582,   584,   586,   588,   590,   592,   594,   596
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
      95,     0,    -1,    96,    97,    99,    -1,   159,     9,    42,
      86,   157,    87,    -1,    98,    -1,    98,    97,    -1,   159,
      45,   156,     4,    14,    86,   158,    87,    -1,   100,    -1,
     100,    99,    -1,   101,    -1,   105,    -1,   143,    -1,   159,
      74,    88,   104,    89,   102,    -1,   159,    74,    88,   104,
      89,   103,   102,    -1,   159,    74,    88,   104,    89,   102,
     103,    -1,   159,    74,    88,   104,    89,   103,    -1,   159,
      74,    88,   104,    89,    -1,    49,    22,    88,    99,    89,
      -1,    49,    67,    88,    99,    89,    -1,   106,    -1,   106,
     104,    -1,   107,    -1,   108,    -1,   109,    -1,   110,    -1,
     114,    -1,   115,    -1,   116,    -1,   117,    -1,   119,    -1,
     120,    -1,   121,    -1,   122,    -1,   123,    -1,   124,    -1,
     125,    -1,   126,    -1,   127,    -1,   128,    -1,   129,    -1,
     130,    -1,   131,    -1,   132,    -1,   133,    -1,   134,    -1,
     135,    -1,   136,    -1,   137,    -1,   138,    -1,   139,    -1,
     140,    -1,   141,    -1,   142,    -1,   111,    -1,   145,    -1,
     113,    87,    -1,   146,    -1,   147,    -1,   105,    -1,   144,
      -1,   159,    19,   158,    87,    -1,   159,    20,   148,    -1,
     159,    25,   112,    87,    -1,   159,    58,    45,   156,    87,
      -1,   159,    59,    45,   148,    -1,    85,    -1,    90,   112,
      -1,   159,     1,    -1,   159,    35,     9,   148,    -1,   159,
      65,    45,   148,    -1,   159,    18,    45,   148,    -1,   159,
      26,    91,   118,    92,    87,    -1,   159,    26,   148,    -1,
      45,    86,    91,   149,    92,    -1,    45,    86,    91,   149,
      92,    93,   118,    -1,   159,    75,    45,   148,    -1,   159,
       8,    53,   148,    -1,   159,     8,    29,   148,    -1,   159,
      65,    52,   148,    -1,   159,    18,    52,   148,    -1,   159,
      65,    37,   148,    -1,   159,    18,    37,   148,    -1,   159,
      17,    64,   148,    -1,   159,    18,    64,   148,    -1,   159,
      40,    64,   148,    -1,   159,    64,     3,    69,   148,    -1,
     159,    64,     3,    62,   148,    -1,   159,    64,    18,    69,
     148,    -1,   159,    64,    18,    62,   148,    -1,   159,    64,
      41,    69,   148,    -1,   159,    64,    41,    62,   148,    -1,
     159,    66,    64,   148,    -1,   159,    77,    64,   148,    -1,
     159,    38,    64,   148,    -1,   159,    76,    64,   148,    -1,
     159,    41,    64,   148,    -1,   159,    24,    60,   148,    -1,
     159,    78,    33,   148,    -1,   159,    57,    13,   148,    -1,
     159,    80,    30,    23,   148,    -1,   159,    80,    30,    23,
     148,    -1,   159,    68,    39,   148,    -1,   159,    81,   148,
      -1,   159,    82,   148,    -1,    87,    -1,    91,   149,    92,
      87,    -1,   150,    -1,   150,    93,   149,    -1,    34,    86,
     151,    -1,    34,    86,   152,    -1,     6,    45,    86,   151,
      -1,    23,    45,    86,   151,    -1,    63,    86,   151,    -1,
       7,    86,   151,    -1,    51,    86,   151,    -1,    47,    51,
      86,   151,    -1,    48,    16,    86,   153,    -1,    43,    51,
      86,   151,    -1,    43,    64,    86,   151,    -1,    56,    86,
     151,    -1,    54,    86,   151,    -1,    15,    86,   151,    -1,
      11,    86,   152,    -1,    14,    86,   152,    -1,    21,    86,
     152,    -1,    64,    34,    86,   151,    -1,     3,    34,    86,
     151,    -1,    45,    34,    86,   151,    -1,    69,    34,    86,
     151,    -1,    32,    55,    42,    86,   152,    -1,    36,    86,
     152,    -1,    31,    86,   153,    -1,    28,    86,   152,    -1,
      51,    86,     5,    -1,    12,    86,   151,    -1,    12,    86,
       5,    -1,    80,    49,    86,   151,    -1,    72,    86,   151,
      -1,    24,    50,    49,    86,   151,    -1,    24,    50,    49,
      86,   152,    -1,    61,    86,   151,    -1,    70,    86,   152,
      -1,    71,    86,   152,    -1,     3,    71,    86,   153,    -1,
     156,    -1,   158,    -1,   154,    -1,   155,    -1,    79,    -1,
      49,    -1,    73,    -1,    44,    -1,    46,    -1,    27,    -1,
      85,    -1,    83,    -1,    84,    -1,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   224,   224,   239,   245,   247,   251,   269,   271,   275,
     277,   279,   283,   300,   318,   336,   353,   370,   373,   377,
     379,   383,   385,   387,   389,   391,   393,   395,   397,   399,
     401,   403,   405,   407,   409,   411,   413,   415,   417,   419,
     421,   423,   425,   427,   429,   431,   433,   435,   437,   439,
     441,   443,   445,   447,   449,   451,   454,   456,   460,   462,
     466,   483,   509,   526,   542,   570,   572,   576,   591,   619,
     649,   706,   721,   752,   775,   799,   825,   855,   883,   915,
     945,   975,  1005,  1035,  1063,  1094,  1134,  1170,  1196,  1224,
    1252,  1282,  1315,  1343,  1371,  1399,  1429,  1462,  1487,  1518,
    1550,  1570,  1596,  1622,  1648,  1650,  1654,  1656,  1660,  1665,
    1670,  1675,  1680,  1685,  1690,  1695,  1700,  1705,  1710,  1715,
    1720,  1725,  1730,  1735,  1740,  1745,  1750,  1755,  1760,  1765,
    1770,  1775,  1780,  1785,  1798,  1803,  1816,  1821,  1826,  1831,
    1836,  1842,  1847,  1852,  1860,  1874,  1888,  1900,  1914,  1915,
    1916,  1919,  1920,  1921,  1924,  1930,  1942,  1955
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "K_ADD", "K_ADMIN", "K_ALL", "K_BACKUP",
  "K_CLIENT", "K_CLONE", "K_CLUSTER", "K_CLUSTERNAME", "K_COMMENT",
  "K_CONFIRMED", "K_CONFIG", "K_CONNINFO", "K_CONNRETRY", "K_COPY",
  "K_CREATE", "K_DROP", "K_ECHO", "K_DATE", "K_DFORMAT", "K_ERROR",
  "K_EVENT", "K_EXECUTE", "K_EXIT", "K_FAILOVER", "K_FALSE", "K_FILENAME",
  "K_FINISH", "K_FOR", "K_FORWARD", "K_FULL", "K_FUNCTIONS", "K_ID",
  "K_INIT", "K_KEY", "K_LISTEN", "K_LOCK", "K_LOG", "K_MERGE", "K_MOVE",
  "K_NAME", "K_NEW", "K_NO", "K_NODE", "K_OFF", "K_OLD", "K_OMIT", "K_ON",
  "K_ONLY", "K_ORIGIN", "K_PATH", "K_PREPARE", "K_PROVIDER", "K_QUALIFIED",
  "K_RECEIVER", "K_REPAIR", "K_RESTART", "K_RESUBSCRIBE", "K_SCRIPT",
  "K_SECONDS", "K_SEQUENCE", "K_SERVER", "K_SET", "K_STORE", "K_SUBSCRIBE",
  "K_SUCCESS", "K_SWITCH", "K_TABLE", "K_TABLES", "K_SEQUENCES",
  "K_TIMEOUT", "K_TRUE", "K_TRY", "K_UNINSTALL", "K_UNLOCK",
  "K_UNSUBSCRIBE", "K_UPDATE", "K_YES", "K_WAIT", "K_SYNC", "K_SLEEP",
  "T_IDENT", "T_LITERAL", "T_NUMBER", "'='", "';'", "'{'", "'}'", "'-'",
  "'('", "')'", "','", "$accept", "script", "hdr_clustername",
  "hdr_admconninfos", "hdr_admconninfo", "stmts", "stmt", "stmt_try",
  "try_on_error", "try_on_success", "try_stmts", "normal_stmt", "try_stmt",
  "stmt_echo", "stmt_date", "stmt_exit", "stmt_restart_node",
  "stmt_resubscribe_node", "exit_code", "stmt_error", "stmt_init_cluster",
  "stmt_store_node", "stmt_drop_node", "stmt_failed_node",
  "fail_node_list", "stmt_uninstall_node", "stmt_clone_prepare",
  "stmt_clone_finish", "stmt_store_path", "stmt_drop_path",
  "stmt_store_listen", "stmt_drop_listen", "stmt_create_set",
  "stmt_drop_set", "stmt_merge_set", "stmt_set_add_table",
  "stmt_set_add_sequence", "stmt_set_drop_table", "stmt_set_drop_sequence",
  "stmt_set_move_table", "stmt_set_move_sequence", "stmt_subscribe_set",
  "stmt_unsubscribe_set", "stmt_lock_set", "stmt_unlock_set",
  "stmt_move_set", "stmt_ddl_script", "stmt_update_functions",
  "stmt_repair_config", "stmt_wait_event", "stmt_wait_inside_try",
  "stmt_switch_log", "stmt_sync", "stmt_sleep", "option_list",
  "option_list_items", "option_list_item", "option_item_id",
  "option_item_literal", "option_item_yn", "option_item_yn_yes",
  "option_item_yn_no", "id", "ident", "literal", "lno", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,    61,    59,   123,   125,
      45,    40,    41,    44
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    94,    95,    96,    97,    97,    98,    99,    99,   100,
     100,   100,   101,   101,   101,   101,   101,   102,   103,   104,
     104,   105,   105,   105,   105,   105,   105,   105,   105,   105,
     105,   105,   105,   105,   105,   105,   105,   105,   105,   105,
     105,   105,   105,   105,   105,   105,   105,   105,   105,   105,
     105,   105,   105,   105,   105,   105,   105,   105,   106,   106,
     107,   108,   109,   110,   111,   112,   112,   113,   114,   115,
     116,   117,   117,   118,   118,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,   143,
     144,   145,   146,   147,   148,   148,   149,   149,   150,   150,
     150,   150,   150,   150,   150,   150,   150,   150,   150,   150,
     150,   150,   150,   150,   150,   150,   150,   150,   150,   150,
     150,   150,   150,   150,   150,   150,   150,   150,   150,   150,
     150,   150,   150,   150,   151,   152,   153,   153,   154,   154,
     154,   155,   155,   155,   156,   157,   158,   159
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     3,     6,     1,     2,     8,     1,     2,     1,
       1,     1,     6,     7,     7,     6,     5,     5,     5,     1,
       2,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     2,     1,     1,     1,     1,
       4,     3,     4,     5,     4,     1,     2,     2,     4,     4,
       4,     6,     3,     5,     7,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     5,     5,     5,     5,     5,
       5,     4,     4,     4,     4,     4,     4,     4,     4,     5,
       5,     4,     3,     3,     1,     4,     1,     3,     3,     3,
       4,     4,     3,     3,     3,     4,     4,     4,     4,     3,
       3,     3,     3,     3,     3,     4,     4,     4,     4,     5,
       3,     3,     3,     3,     3,     3,     4,     3,     5,     5,
       3,     3,     3,     4,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     0
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
     157,     0,   157,     0,     1,   157,     4,     0,     0,     2,
     157,     9,    10,    21,    22,    23,    24,    53,     0,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    11,    54,    56,
      57,     0,     5,     0,     0,     8,    55,    67,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   154,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   156,     0,   104,     0,    61,
       0,    65,     0,     0,     0,    72,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   157,     0,     0,     0,     0,     0,   102,   103,     0,
     155,     0,    77,    76,    82,    81,    70,    79,    83,    60,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   106,    96,    66,    62,     0,     0,    68,    93,    84,
      95,    98,     0,    64,     0,     0,     0,     0,     0,     0,
      80,    69,    78,    91,   101,     0,    58,   157,    59,     0,
      75,    94,    92,    97,     0,     0,     3,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    63,    86,    85,    88,    87,    90,    89,
      16,    20,     0,    99,     0,     0,     0,     0,   113,   144,
     122,   145,   135,   134,   123,   121,   124,     0,     0,   132,
     153,   151,   152,   149,   150,   148,   131,   146,   147,     0,
     108,   109,   130,     0,     0,     0,     0,     0,   133,   114,
     120,   119,   140,   112,     0,     0,   141,   142,   137,     0,
     105,   107,     0,    71,     0,    12,    15,     0,     0,   126,
     143,   110,   111,     0,     0,   117,   118,   127,   115,   116,
     125,   128,   136,     0,     0,     0,     0,    14,     0,    13,
       0,     6,   138,   139,   129,    73,   157,   157,   100,     0,
       0,     0,     0,    74,    17,    18
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     1,     2,     5,     6,     9,    10,    11,   305,   306,
     195,    12,   197,    13,    14,    15,    16,    17,   103,    18,
      19,    20,    21,    22,   176,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
     198,    48,    49,    50,    99,   170,   171,   258,   260,   276,
     277,   278,   259,   131,   261,    51
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -241
static const yytype_int16 yypact[] =
{
    -241,    17,  -241,    14,  -241,  -241,   -14,    -6,     9,  -241,
       3,  -241,  -241,  -241,  -241,  -241,  -241,  -241,   -46,  -241,
    -241,  -241,  -241,  -241,  -241,  -241,  -241,  -241,  -241,  -241,
    -241,  -241,  -241,  -241,  -241,  -241,  -241,  -241,  -241,  -241,
    -241,  -241,  -241,  -241,  -241,  -241,  -241,  -241,  -241,  -241,
    -241,   140,  -241,   -28,   -20,  -241,  -241,  -241,   -15,    13,
      51,    20,     8,    23,   -53,    10,    65,    34,    42,    50,
     103,    73,    74,    32,    57,    63,    89,    41,    85,    67,
      68,   105,   109,     8,     8,  -241,   138,    69,     8,     8,
       8,     8,     8,     8,     8,  -241,    59,  -241,   297,  -241,
       8,  -241,   -53,    60,   367,  -241,     8,     8,     8,     8,
       8,   -28,     8,   -47,   -29,    31,     8,     8,     8,     8,
       8,  -241,     8,     8,     8,     8,   127,  -241,  -241,   137,
    -241,    66,  -241,  -241,  -241,  -241,  -241,  -241,  -241,  -241,
     -22,   110,    70,    75,    76,    83,    84,    86,   126,   104,
      87,    88,   121,    91,    93,   -30,   148,   132,   168,    99,
     100,   101,   102,   106,   155,   156,   107,   108,   114,   142,
     111,   116,  -241,  -241,  -241,   -21,   115,  -241,  -241,  -241,
    -241,  -241,   123,  -241,     8,     8,     8,     8,     8,     8,
    -241,  -241,  -241,  -241,  -241,   112,  -241,   122,  -241,   211,
    -241,  -241,  -241,  -241,     8,   139,  -241,   141,   146,   147,
     -28,    20,    -1,    20,   -28,    20,   152,   164,    20,    64,
     154,    27,    20,   153,   157,   158,   159,   161,     1,   -28,
     -28,   -28,   -28,   162,   167,    20,    20,   -28,   169,   136,
     297,   133,   163,  -241,  -241,  -241,  -241,  -241,  -241,  -241,
     177,  -241,   204,  -241,    20,   -28,    64,   -28,  -241,  -241,
    -241,  -241,  -241,  -241,  -241,  -241,  -241,   -28,   170,  -241,
    -241,  -241,  -241,  -241,  -241,  -241,  -241,  -241,  -241,   171,
    -241,  -241,  -241,   -28,   -28,   -28,   -28,    64,  -241,  -241,
    -241,  -241,  -241,  -241,   -28,   -28,  -241,  -241,  -241,   -28,
    -241,  -241,   297,  -241,    -4,   191,   192,   219,   172,  -241,
    -241,  -241,  -241,    27,    20,  -241,  -241,  -241,  -241,  -241,
    -241,  -241,  -241,   166,   173,   174,   187,  -241,   238,  -241,
       8,  -241,  -241,  -241,  -241,   178,  -241,  -241,  -241,   218,
     175,   176,   181,  -241,  -241,  -241
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -241,  -241,  -241,   266,  -241,   -10,  -241,  -241,   -33,   -31,
      81,  -112,  -241,  -241,  -241,  -241,  -241,  -241,   179,  -241,
    -241,  -241,  -241,  -241,   -57,  -241,  -241,  -241,  -241,  -241,
    -241,  -241,  -241,  -241,  -241,  -241,  -241,  -241,  -241,  -241,
    -241,  -241,  -241,  -241,  -241,  -241,  -241,  -241,  -241,  -241,
    -241,  -241,  -241,  -241,   -64,  -232,  -241,  -150,  -146,  -240,
    -241,  -241,   -43,  -241,   -59,     5
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -158
static const yytype_int16 yytable[] =
{
      55,   105,    96,    -7,   262,     3,   288,     7,   301,   196,
      86,     7,   207,   225,    88,   184,   310,     4,   324,   127,
     128,   223,   185,     8,   132,   133,   134,   135,   136,   137,
     138,  -157,   101,   186,   224,   113,   172,   102,    89,    53,
     187,    56,   177,   178,   179,   180,   181,   319,   183,   208,
     114,    54,   190,   191,   192,   193,   194,    85,   200,   201,
     202,   203,   263,   325,   265,   241,    87,   264,   182,   266,
     323,   280,   269,   115,   106,   281,   282,    90,   289,   290,
     291,   292,   293,   100,    85,   196,    85,   298,    91,   296,
     297,   270,    -7,   188,   116,    97,    92,    97,   107,    98,
     189,   104,   117,    93,    95,   309,   108,   311,   271,   118,
     272,    95,    85,   273,   109,    94,   110,   312,   111,   112,
     244,   245,   246,   247,   248,   249,   199,   119,   120,   121,
     122,   123,   124,   315,   316,   317,   318,   274,   125,   126,
     253,    57,   129,   275,   320,   321,   139,   174,    58,   322,
     204,   205,   130,   206,   217,   209,   210,    59,    60,    61,
      62,   211,   212,   332,    63,    64,    65,   333,   334,   213,
     214,   216,   215,   218,   219,    66,   220,   221,    67,   222,
      68,    69,   225,   226,   227,   228,   229,   230,   231,   233,
     234,   238,   232,   235,   236,   308,   279,    70,    71,    72,
     237,   250,   199,   239,    73,    74,    75,   242,    76,   240,
     243,   -19,    57,   268,    77,    78,    79,    80,    81,    58,
      82,    83,    84,   300,   302,   254,   304,   255,    59,    60,
      61,    62,   256,   257,   307,    63,    64,    65,   267,   283,
     326,   328,   330,   284,   285,   286,    66,   287,   294,    67,
     303,    68,    69,   295,   325,   299,   313,   314,   335,   331,
     324,   336,   337,   342,   344,   345,   338,   241,    70,    71,
      72,   339,    52,   329,   327,    73,    74,    75,   251,    76,
       0,   173,   343,     0,     0,     0,    78,    79,    80,    81,
       0,   252,    83,    84,     0,     0,     0,     0,     0,     0,
     140,     0,     0,   141,   142,     0,     0,     0,   143,   144,
       0,   145,   146,     0,     0,     0,     0,     0,   147,     0,
     148,   149,     0,     0,     0,   150,   340,   341,   151,   152,
       0,   153,     0,   154,     0,     0,     0,     0,     0,     0,
     155,     0,   156,     0,   157,   158,     0,     0,   159,     0,
       0,   160,     0,   161,     0,     0,     0,     0,   162,     0,
     163,   164,     0,     0,     0,     0,   165,   166,   167,   168,
     140,     0,     0,   141,   142,     0,     0,   169,   143,   144,
       0,   145,   146,     0,     0,     0,     0,     0,   147,     0,
     148,   149,     0,     0,     0,   150,     0,     0,   151,   152,
       0,   153,     0,   154,     0,     0,     0,     0,     0,     0,
     155,     0,   175,     0,   157,   158,     0,     0,   159,     0,
       0,   160,     0,   161,     0,     0,     0,     0,   162,     0,
     163,   164,     0,     0,     0,     0,   165,   166,   167,   168,
       0,     0,     0,     0,     0,     0,     0,   169
};

static const yytype_int16 yycheck[] =
{
      10,    65,    61,     0,     5,     0,     5,     2,   240,   121,
      53,     6,    34,    34,    29,    62,   256,     0,    22,    83,
      84,    51,    69,     9,    88,    89,    90,    91,    92,    93,
      94,    45,    85,    62,    64,     3,   100,    90,    53,    45,
      69,    87,   106,   107,   108,   109,   110,   287,   112,    71,
      18,    42,   116,   117,   118,   119,   120,    85,   122,   123,
     124,   125,   212,    67,   214,    86,    86,   213,   111,   215,
     302,   221,   218,    41,     9,   221,   222,    64,   228,   229,
     230,   231,   232,    60,    85,   197,    85,   237,    37,   235,
     236,    27,    89,    62,    37,    87,    45,    87,    64,    91,
      69,    91,    45,    52,    84,   255,    64,   257,    44,    52,
      46,    84,    85,    49,    64,    64,    13,   267,    45,    45,
     184,   185,   186,   187,   188,   189,   121,    64,    39,    88,
      45,    64,    64,   283,   284,   285,   286,    73,    33,    30,
     204,     1,     4,    79,   294,   295,    87,    87,     8,   299,
      23,    14,    83,    87,    50,    45,    86,    17,    18,    19,
      20,    86,    86,   313,    24,    25,    26,   313,   314,    86,
      86,    45,    86,    86,    86,    35,    55,    86,    38,    86,
      40,    41,    34,    51,    16,    86,    86,    86,    86,    34,
      34,    49,    86,    86,    86,   254,    42,    57,    58,    59,
      86,    89,   197,    92,    64,    65,    66,    92,    68,    93,
      87,    89,     1,    49,    74,    75,    76,    77,    78,     8,
      80,    81,    82,    87,    91,    86,    49,    86,    17,    18,
      19,    20,    86,    86,    30,    24,    25,    26,    86,    86,
      49,    49,    23,    86,    86,    86,    35,    86,    86,    38,
      87,    40,    41,    86,    67,    86,    86,    86,    92,    87,
      22,    88,    88,    45,    89,    89,   330,    86,    57,    58,
      59,    93,     6,   306,   305,    64,    65,    66,   197,    68,
      -1,   102,   339,    -1,    -1,    -1,    75,    76,    77,    78,
      -1,    80,    81,    82,    -1,    -1,    -1,    -1,    -1,    -1,
       3,    -1,    -1,     6,     7,    -1,    -1,    -1,    11,    12,
      -1,    14,    15,    -1,    -1,    -1,    -1,    -1,    21,    -1,
      23,    24,    -1,    -1,    -1,    28,   336,   337,    31,    32,
      -1,    34,    -1,    36,    -1,    -1,    -1,    -1,    -1,    -1,
      43,    -1,    45,    -1,    47,    48,    -1,    -1,    51,    -1,
      -1,    54,    -1,    56,    -1,    -1,    -1,    -1,    61,    -1,
      63,    64,    -1,    -1,    -1,    -1,    69,    70,    71,    72,
       3,    -1,    -1,     6,     7,    -1,    -1,    80,    11,    12,
      -1,    14,    15,    -1,    -1,    -1,    -1,    -1,    21,    -1,
      23,    24,    -1,    -1,    -1,    28,    -1,    -1,    31,    32,
      -1,    34,    -1,    36,    -1,    -1,    -1,    -1,    -1,    -1,
      43,    -1,    45,    -1,    47,    48,    -1,    -1,    51,    -1,
      -1,    54,    -1,    56,    -1,    -1,    -1,    -1,    61,    -1,
      63,    64,    -1,    -1,    -1,    -1,    69,    70,    71,    72,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    80
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    95,    96,   159,     0,    97,    98,   159,     9,    99,
     100,   101,   105,   107,   108,   109,   110,   111,   113,   114,
     115,   116,   117,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   145,   146,
     147,   159,    97,    45,    42,    99,    87,     1,     8,    17,
      18,    19,    20,    24,    25,    26,    35,    38,    40,    41,
      57,    58,    59,    64,    65,    66,    68,    74,    75,    76,
      77,    78,    80,    81,    82,    85,   156,    86,    29,    53,
      64,    37,    45,    52,    64,    84,   158,    87,    91,   148,
      60,    85,    90,   112,    91,   148,     9,    64,    64,    64,
      13,    45,    45,     3,    18,    41,    37,    45,    52,    64,
      39,    88,    45,    64,    64,    33,    30,   148,   148,     4,
      83,   157,   148,   148,   148,   148,   148,   148,   148,    87,
       3,     6,     7,    11,    12,    14,    15,    21,    23,    24,
      28,    31,    32,    34,    36,    43,    45,    47,    48,    51,
      54,    56,    61,    63,    64,    69,    70,    71,    72,    80,
     149,   150,   148,   112,    87,    45,   118,   148,   148,   148,
     148,   148,   156,   148,    62,    69,    62,    69,    62,    69,
     148,   148,   148,   148,   148,   104,   105,   106,   144,   159,
     148,   148,   148,   148,    23,    14,    87,    34,    71,    45,
      86,    86,    86,    86,    86,    86,    45,    50,    86,    86,
      55,    86,    86,    51,    64,    34,    51,    16,    86,    86,
      86,    86,    86,    34,    34,    86,    86,    86,    49,    92,
      93,    86,    92,    87,   148,   148,   148,   148,   148,   148,
      89,   104,    80,   148,    86,    86,    86,    86,   151,   156,
     152,   158,     5,   151,   152,   151,   152,    86,    49,   152,
      27,    44,    46,    49,    73,    79,   153,   154,   155,    42,
     151,   152,   152,    86,    86,    86,    86,    86,     5,   151,
     151,   151,   151,   151,    86,    86,   152,   152,   151,    86,
      87,   149,    91,    87,    49,   102,   103,    30,   158,   151,
     153,   151,   151,    86,    86,   151,   151,   151,   151,   153,
     151,   151,   151,   149,    22,    67,    49,   103,    49,   102,
      23,    87,   151,   152,   152,    92,    88,    88,   148,    93,
      99,    99,    45,   118,    89,    89
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}

/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */


/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*-------------------------.
| yyparse or yypush_parse.  |
`-------------------------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{


    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:

/* Line 1455 of yacc.c  */
#line 227 "parser.y"
    {
						parser_script = (SlonikScript *)
								malloc(sizeof(SlonikScript));
						memset(parser_script, 0, sizeof(SlonikScript));

						parser_script->clustername		= (yyvsp[(1) - (3)].str);
						parser_script->filename			= current_file;
						parser_script->adminfo_list		= (yyvsp[(2) - (3)].adm_info);
						parser_script->script_stmts		= (yyvsp[(3) - (3)].statement);
					}
    break;

  case 3:

/* Line 1455 of yacc.c  */
#line 240 "parser.y"
    {
						(yyval.str) = (yyvsp[(5) - (6)].str);
					}
    break;

  case 4:

/* Line 1455 of yacc.c  */
#line 246 "parser.y"
    { (yyval.adm_info) = (yyvsp[(1) - (1)].adm_info); }
    break;

  case 5:

/* Line 1455 of yacc.c  */
#line 248 "parser.y"
    { (yyvsp[(1) - (2)].adm_info)->next = (yyvsp[(2) - (2)].adm_info); (yyval.adm_info) = (yyvsp[(1) - (2)].adm_info); }
    break;

  case 6:

/* Line 1455 of yacc.c  */
#line 252 "parser.y"
    {
						SlonikAdmInfo	   *new;

						new = (SlonikAdmInfo *)
								malloc(sizeof(SlonikAdmInfo));
						memset(new, 0, sizeof(SlonikAdmInfo));

						new->no_id			= (yyvsp[(3) - (8)].ival);
						new->stmt_filename	= current_file;
						new->stmt_lno		= (yyvsp[(1) - (8)].ival);
						new->conninfo		= (yyvsp[(7) - (8)].str);
						new->last_event		= -1;

						(yyval.adm_info) = new;
					}
    break;

  case 7:

/* Line 1455 of yacc.c  */
#line 270 "parser.y"
    { (yyval.statement) = (yyvsp[(1) - (1)].statement); }
    break;

  case 8:

/* Line 1455 of yacc.c  */
#line 272 "parser.y"
    { (yyvsp[(1) - (2)].statement)->next = (yyvsp[(2) - (2)].statement); (yyval.statement) = (yyvsp[(1) - (2)].statement); }
    break;

  case 9:

/* Line 1455 of yacc.c  */
#line 276 "parser.y"
    { (yyval.statement) = (yyvsp[(1) - (1)].statement); }
    break;

  case 10:

/* Line 1455 of yacc.c  */
#line 278 "parser.y"
    { (yyval.statement) = (yyvsp[(1) - (1)].statement); }
    break;

  case 11:

/* Line 1455 of yacc.c  */
#line 280 "parser.y"
    { (yyval.statement) = (yyvsp[(1) - (1)].statement); }
    break;

  case 12:

/* Line 1455 of yacc.c  */
#line 285 "parser.y"
    {
						SlonikStmt_try *new;

						new = (SlonikStmt_try *)
								malloc(sizeof(SlonikStmt_try));
						memset(new, 0, sizeof(SlonikStmt_try));
						new->hdr.stmt_type		= STMT_TRY;
						new->hdr.stmt_filename	= current_file;
						new->hdr.stmt_lno		= (yyvsp[(1) - (6)].ival);

						new->try_block = (yyvsp[(4) - (6)].statement);
						new->error_block = (yyvsp[(6) - (6)].statement);

						(yyval.statement) = (SlonikStmt *)new;
					}
    break;

  case 13:

/* Line 1455 of yacc.c  */
#line 302 "parser.y"
    {
						SlonikStmt_try *new;

						new = (SlonikStmt_try *)
								malloc(sizeof(SlonikStmt_try));
						memset(new, 0, sizeof(SlonikStmt_try));
						new->hdr.stmt_type		= STMT_TRY;
						new->hdr.stmt_filename	= current_file;
						new->hdr.stmt_lno		= (yyvsp[(1) - (7)].ival);

						new->try_block = (yyvsp[(4) - (7)].statement);
						new->success_block = (yyvsp[(6) - (7)].statement);
						new->error_block = (yyvsp[(7) - (7)].statement);

						(yyval.statement) = (SlonikStmt *)new;
					}
    break;

  case 14:

/* Line 1455 of yacc.c  */
#line 320 "parser.y"
    {
						SlonikStmt_try *new;

						new = (SlonikStmt_try *)
								malloc(sizeof(SlonikStmt_try));
						memset(new, 0, sizeof(SlonikStmt_try));
						new->hdr.stmt_type		= STMT_TRY;
						new->hdr.stmt_filename	= current_file;
						new->hdr.stmt_lno		= (yyvsp[(1) - (7)].ival);

						new->try_block = (yyvsp[(4) - (7)].statement);
						new->success_block = (yyvsp[(7) - (7)].statement);
						new->error_block = (yyvsp[(6) - (7)].statement);

						(yyval.statement) = (SlonikStmt *)new;
					}
    break;

  case 15:

/* Line 1455 of yacc.c  */
#line 338 "parser.y"
    {
						SlonikStmt_try *new;

						new = (SlonikStmt_try *)
								malloc(sizeof(SlonikStmt_try));
						memset(new, 0, sizeof(SlonikStmt_try));
						new->hdr.stmt_type		= STMT_TRY;
						new->hdr.stmt_filename	= current_file;
						new->hdr.stmt_lno		= (yyvsp[(1) - (6)].ival);

						new->try_block = (yyvsp[(4) - (6)].statement);
						new->success_block = (yyvsp[(6) - (6)].statement);

						(yyval.statement) = (SlonikStmt *)new;
					}
    break;

  case 16:

/* Line 1455 of yacc.c  */
#line 354 "parser.y"
    {
						SlonikStmt_try *new;

						new = (SlonikStmt_try *)
								malloc(sizeof(SlonikStmt_try));
						memset(new, 0, sizeof(SlonikStmt_try));
						new->hdr.stmt_type		= STMT_TRY;
						new->hdr.stmt_filename	= current_file;
						new->hdr.stmt_lno		= (yyvsp[(1) - (5)].ival);

						new->try_block = (yyvsp[(4) - (5)].statement);

						(yyval.statement) = (SlonikStmt *)new;
					}
    break;

  case 17:

/* Line 1455 of yacc.c  */
#line 371 "parser.y"
    { (yyval.statement) = (yyvsp[(4) - (5)].statement); }
    break;

  case 18:

/* Line 1455 of yacc.c  */
#line 374 "parser.y"
    { (yyval.statement) = (yyvsp[(4) - (5)].statement); }
    break;

  case 19:

/* Line 1455 of yacc.c  */
#line 378 "parser.y"
    { (yyval.statement) = (yyvsp[(1) - (1)].statement); }
    break;

  case 20:

/* Line 1455 of yacc.c  */
#line 380 "parser.y"
    { (yyvsp[(1) - (2)].statement)->next = (yyvsp[(2) - (2)].statement); (yyval.statement) = (yyvsp[(1) - (2)].statement); }
    break;

  case 21:

/* Line 1455 of yacc.c  */
#line 384 "parser.y"
    { (yyval.statement) = (yyvsp[(1) - (1)].statement); }
    break;

  case 22:

/* Line 1455 of yacc.c  */
#line 386 "parser.y"
    { (yyval.statement) = (yyvsp[(1) - (1)].statement); }
    break;

  case 23:

/* Line 1455 of yacc.c  */
#line 388 "parser.y"
    { (yyval.statement) = (yyvsp[(1) - (1)].statement); }
    break;

  case 24:

/* Line 1455 of yacc.c  */
#line 390 "parser.y"
    { (yyval.statement) = (yyvsp[(1) - (1)].statement); }
    break;

  case 25:

/* Line 1455 of yacc.c  */
#line 392 "parser.y"
    { (yyval.statement) = (yyvsp[(1) - (1)].statement); }
    break;

  case 26:

/* Line 1455 of yacc.c  */
#line 394 "parser.y"
    { (yyval.statement) = (yyvsp[(1) - (1)].statement); }
    break;

  case 27:

/* Line 1455 of yacc.c  */
#line 396 "parser.y"
    { (yyval.statement) = (yyvsp[(1) - (1)].statement); }
    break;

  case 28:

/* Line 1455 of yacc.c  */
#line 398 "parser.y"
    { (yyval.statement) = (yyvsp[(1) - (1)].statement); }
    break;

  case 29:

/* Line 1455 of yacc.c  */
#line 400 "parser.y"
    { (yyval.statement) = (yyvsp[(1) - (1)].statement); }
    break;

  case 30:

/* Line 1455 of yacc.c  */
#line 402 "parser.y"
    { (yyval.statement) = (yyvsp[(1) - (1)].statement); }
    break;

  case 31:

/* Line 1455 of yacc.c  */
#line 404 "parser.y"
    { (yyval.statement) = (yyvsp[(1) - (1)].statement); }
    break;

  case 32:

/* Line 1455 of yacc.c  */
#line 406 "parser.y"
    { (yyval.statement) = (yyvsp[(1) - (1)].statement); }
    break;

  case 33:

/* Line 1455 of yacc.c  */
#line 408 "parser.y"
    { (yyval.statement) = (yyvsp[(1) - (1)].statement); }
    break;

  case 34:

/* Line 1455 of yacc.c  */
#line 410 "parser.y"
    { (yyval.statement) = (yyvsp[(1) - (1)].statement); }
    break;

  case 35:

/* Line 1455 of yacc.c  */
#line 412 "parser.y"
    { (yyval.statement) = (yyvsp[(1) - (1)].statement); }
    break;

  case 36:

/* Line 1455 of yacc.c  */
#line 414 "parser.y"
    { (yyval.statement) = (yyvsp[(1) - (1)].statement); }
    break;

  case 37:

/* Line 1455 of yacc.c  */
#line 416 "parser.y"
    { (yyval.statement) = (yyvsp[(1) - (1)].statement); }
    break;

  case 38:

/* Line 1455 of yacc.c  */
#line 418 "parser.y"
    { (yyval.statement) = (yyvsp[(1) - (1)].statement); }
    break;

  case 39:

/* Line 1455 of yacc.c  */
#line 420 "parser.y"
    { (yyval.statement) = (yyvsp[(1) - (1)].statement); }
    break;

  case 40:

/* Line 1455 of yacc.c  */
#line 422 "parser.y"
    { (yyval.statement) = (yyvsp[(1) - (1)].statement); }
    break;

  case 41:

/* Line 1455 of yacc.c  */
#line 424 "parser.y"
    { (yyval.statement) = (yyvsp[(1) - (1)].statement); }
    break;

  case 42:

/* Line 1455 of yacc.c  */
#line 426 "parser.y"
    { (yyval.statement) = (yyvsp[(1) - (1)].statement); }
    break;

  case 43:

/* Line 1455 of yacc.c  */
#line 428 "parser.y"
    { (yyval.statement) = (yyvsp[(1) - (1)].statement); }
    break;

  case 44:

/* Line 1455 of yacc.c  */
#line 430 "parser.y"
    { (yyval.statement) = (yyvsp[(1) - (1)].statement); }
    break;

  case 45:

/* Line 1455 of yacc.c  */
#line 432 "parser.y"
    { (yyval.statement) = (yyvsp[(1) - (1)].statement); }
    break;

  case 46:

/* Line 1455 of yacc.c  */
#line 434 "parser.y"
    { (yyval.statement) = (yyvsp[(1) - (1)].statement); }
    break;

  case 47:

/* Line 1455 of yacc.c  */
#line 436 "parser.y"
    { (yyval.statement) = (yyvsp[(1) - (1)].statement); }
    break;

  case 48:

/* Line 1455 of yacc.c  */
#line 438 "parser.y"
    { (yyval.statement) = (yyvsp[(1) - (1)].statement); }
    break;

  case 49:

/* Line 1455 of yacc.c  */
#line 440 "parser.y"
    { (yyval.statement) = (yyvsp[(1) - (1)].statement); }
    break;

  case 50:

/* Line 1455 of yacc.c  */
#line 442 "parser.y"
    { (yyval.statement) = (yyvsp[(1) - (1)].statement); }
    break;

  case 51:

/* Line 1455 of yacc.c  */
#line 444 "parser.y"
    { (yyval.statement) = (yyvsp[(1) - (1)].statement); }
    break;

  case 52:

/* Line 1455 of yacc.c  */
#line 446 "parser.y"
    { (yyval.statement) = (yyvsp[(1) - (1)].statement); }
    break;

  case 53:

/* Line 1455 of yacc.c  */
#line 448 "parser.y"
    { (yyval.statement) = (yyvsp[(1) - (1)].statement); }
    break;

  case 54:

/* Line 1455 of yacc.c  */
#line 450 "parser.y"
    { (yyval.statement) = (yyvsp[(1) - (1)].statement); }
    break;

  case 55:

/* Line 1455 of yacc.c  */
#line 452 "parser.y"
    { yyerrok;
						  (yyval.statement) = (yyvsp[(1) - (2)].statement); }
    break;

  case 56:

/* Line 1455 of yacc.c  */
#line 455 "parser.y"
    { (yyval.statement) = (yyvsp[(1) - (1)].statement); }
    break;

  case 57:

/* Line 1455 of yacc.c  */
#line 457 "parser.y"
    { (yyval.statement) = (yyvsp[(1) - (1)].statement); }
    break;

  case 58:

/* Line 1455 of yacc.c  */
#line 461 "parser.y"
    { (yyval.statement) = (yyvsp[(1) - (1)].statement); }
    break;

  case 59:

/* Line 1455 of yacc.c  */
#line 463 "parser.y"
    { (yyval.statement) = (yyvsp[(1) - (1)].statement); }
    break;

  case 60:

/* Line 1455 of yacc.c  */
#line 467 "parser.y"
    {
						SlonikStmt_echo *new;

						new = (SlonikStmt_echo *)
								malloc(sizeof(SlonikStmt_echo));
						memset(new, 0, sizeof(SlonikStmt_echo));
						new->hdr.stmt_type		= STMT_ECHO;
						new->hdr.stmt_filename	= current_file;
						new->hdr.stmt_lno		= (yyvsp[(1) - (4)].ival);

						new->str = (yyvsp[(3) - (4)].str);

						(yyval.statement) = (SlonikStmt *)new;
					}
    break;

  case 61:

/* Line 1455 of yacc.c  */
#line 484 "parser.y"
    {
						SlonikStmt_date *new;
						statement_option opt[] = {
							STMT_OPTION_STR( O_DATE_FORMAT, "%F %T"),
							STMT_OPTION_END
						};

						new = (SlonikStmt_date *)
								malloc(sizeof(SlonikStmt_date));
						memset(new, 0, sizeof(SlonikStmt_date));
						new->hdr.stmt_type		= STMT_DATE;
						new->hdr.stmt_filename	= current_file;
						new->hdr.stmt_lno		= (yyvsp[(1) - (3)].ival);

						if (assign_options(opt, (yyvsp[(3) - (3)].opt_list)) == 0)
						{
							new->fmt = opt[0].str;
						}
						else
							parser_errors++;

						(yyval.statement) = (SlonikStmt *)new;
					}
    break;

  case 62:

/* Line 1455 of yacc.c  */
#line 510 "parser.y"
    {
						SlonikStmt_exit *new;

						new = (SlonikStmt_exit *)
								malloc(sizeof(SlonikStmt_exit));
						memset(new, 0, sizeof(SlonikStmt_exit));
						new->hdr.stmt_type		= STMT_EXIT;
						new->hdr.stmt_filename	= current_file;
						new->hdr.stmt_lno		= (yyvsp[(1) - (4)].ival);

						new->exitcode = (yyvsp[(3) - (4)].ival);

						(yyval.statement) = (SlonikStmt *)new;
					}
    break;

  case 63:

/* Line 1455 of yacc.c  */
#line 527 "parser.y"
    {
						SlonikStmt_restart_node *new;

						new = (SlonikStmt_restart_node *)
								malloc(sizeof(SlonikStmt_restart_node));
						memset(new, 0, sizeof(SlonikStmt_restart_node));
						new->hdr.stmt_type		= STMT_RESTART_NODE;
						new->hdr.stmt_filename	= current_file;
						new->hdr.stmt_lno		= (yyvsp[(1) - (5)].ival);

						new->no_id = (yyvsp[(4) - (5)].ival);

						(yyval.statement) = (SlonikStmt *)new;
					}
    break;

  case 64:

/* Line 1455 of yacc.c  */
#line 543 "parser.y"
    {
						SlonikStmt_resubscribe_node * new;
						statement_option opt[] = {
							STMT_OPTION_INT( O_ORIGIN, -1 ),
							STMT_OPTION_INT( O_PROVIDER, -1 ),
							STMT_OPTION_INT( O_RECEIVER, -1),
							STMT_OPTION_END
						};

						new = (SlonikStmt_resubscribe_node *)
								malloc(sizeof(SlonikStmt_resubscribe_node));
						memset(new, 0, sizeof(SlonikStmt_resubscribe_node));
						new->hdr.stmt_type		= STMT_RESUBSCRIBE_NODE;
						new->hdr.stmt_filename	= current_file;
						new->hdr.stmt_lno		= (yyvsp[(1) - (4)].ival);

						if (assign_options(opt, (yyvsp[(4) - (4)].opt_list)) == 0)
						{
							new->no_origin		= opt[0].ival;
							new->no_provider	= opt[1].ival;
							new->no_receiver	= opt[2].ival;
						}
						else
							parser_errors++;
						(yyval.statement) = (SlonikStmt *)new;
					}
    break;

  case 65:

/* Line 1455 of yacc.c  */
#line 571 "parser.y"
    { (yyval.ival) = strtol(yytext, NULL, 10); }
    break;

  case 66:

/* Line 1455 of yacc.c  */
#line 573 "parser.y"
    { (yyval.ival) = -(yyvsp[(2) - (2)].ival); }
    break;

  case 67:

/* Line 1455 of yacc.c  */
#line 577 "parser.y"
    {
						SlonikStmt *new;

						new = (SlonikStmt *)
								malloc(sizeof(SlonikStmt));
						memset(new, 0, sizeof(SlonikStmt));
						new->stmt_type		= STMT_ERROR;
						new->stmt_filename	= current_file;
						new->stmt_lno		= (yyvsp[(1) - (2)].ival);

						(yyval.statement) = (SlonikStmt *)new;
					}
    break;

  case 68:

/* Line 1455 of yacc.c  */
#line 592 "parser.y"
    {
						SlonikStmt_init_cluster *new;
						statement_option opt[] = {
							STMT_OPTION_INT( O_ID, -1 ),
							STMT_OPTION_STR( O_COMMENT, "Initial Node" ),
							STMT_OPTION_END
						};

						new = (SlonikStmt_init_cluster *)
								malloc(sizeof(SlonikStmt_init_cluster));
						memset(new, 0, sizeof(SlonikStmt_init_cluster));
						new->hdr.stmt_type		= STMT_INIT_CLUSTER;
						new->hdr.stmt_filename	= current_file;
						new->hdr.stmt_lno		= (yyvsp[(1) - (4)].ival);

						if (assign_options(opt, (yyvsp[(4) - (4)].opt_list)) == 0)
						{
							new->no_id			= opt[0].ival;
							new->no_comment		= opt[1].str;
						}
						else
							parser_errors++;

						(yyval.statement) = (SlonikStmt *)new;
					}
    break;

  case 69:

/* Line 1455 of yacc.c  */
#line 620 "parser.y"
    {
						SlonikStmt_store_node *new;
						statement_option opt[] = {
							STMT_OPTION_INT( O_ID, -1 ),
							STMT_OPTION_STR( O_COMMENT, NULL ),
							STMT_OPTION_INT( O_EVENT_NODE, -1 ),
							STMT_OPTION_END
						};

						new = (SlonikStmt_store_node *)
								malloc(sizeof(SlonikStmt_store_node));
						memset(new, 0, sizeof(SlonikStmt_store_node));
						new->hdr.stmt_type		= STMT_STORE_NODE;
						new->hdr.stmt_filename	= current_file;
						new->hdr.stmt_lno		= (yyvsp[(1) - (4)].ival);

						if (assign_options(opt, (yyvsp[(4) - (4)].opt_list)) == 0)
						{
							new->no_id			= opt[0].ival;
							new->no_comment		= opt[1].str;
							new->ev_origin		= opt[2].ival;
						}
						else
							parser_errors++;

						(yyval.statement) = (SlonikStmt *)new;
					}
    break;

  case 70:

/* Line 1455 of yacc.c  */
#line 650 "parser.y"
    {
						SlonikStmt_drop_node *new;
						statement_option opt[] = {
							STMT_OPTION_STR( O_ID, NULL ),
							STMT_OPTION_INT( O_ID, -1 ),
							STMT_OPTION_INT( O_EVENT_NODE, -1 ),
							STMT_OPTION_END
						};

						new = (SlonikStmt_drop_node *)
								malloc(sizeof(SlonikStmt_drop_node));
						memset(new, 0, sizeof(SlonikStmt_drop_node));
						new->hdr.stmt_type		= STMT_DROP_NODE;
						new->hdr.stmt_filename	= current_file;
						new->hdr.stmt_lno		= (yyvsp[(1) - (4)].ival);

						if (assign_options(opt, (yyvsp[(4) - (4)].opt_list)) == 0)
						{
							if(opt[0].ival > -1 )
							{
								new->no_id_list=malloc(sizeof(int)*2);
								new->no_id_list[0]=opt[0].ival;
								new->no_id_list[1]=-1;
							}
							else 
							{
								char * token;
								char * saveptr=NULL;
								int cnt;
								char * option_copy=strdup(opt[0].str);
								for(cnt=0,token=strtok_r(option_copy,",",
														 &saveptr);
									token != NULL; cnt++, 
										token=strtok_r(NULL,",",&saveptr));
								free(option_copy);
								new->no_id_list=malloc(sizeof(int)*(cnt+1));
								cnt=0;
								option_copy=strdup(opt[0].str);
								for(token=strtok_r(option_copy,",",&saveptr);
									token!=NULL;
									token=strtok_r(NULL,",",&saveptr))
								{
									new->no_id_list[cnt++]=atoi(token);
								}
								free(option_copy);
								new->no_id_list[cnt]=-1;
							}
							new->ev_origin		= opt[2].ival;
							
						}
						else
							parser_errors++;

						(yyval.statement) = (SlonikStmt *)new;
					}
    break;

  case 71:

/* Line 1455 of yacc.c  */
#line 707 "parser.y"
    {
						SlonikStmt_failed_node *new;
					
						new = (SlonikStmt_failed_node *)
								malloc(sizeof(SlonikStmt_failed_node));
						memset(new, 0, sizeof(SlonikStmt_failed_node));
						new->hdr.stmt_type		= STMT_FAILED_NODE;
						new->hdr.stmt_filename	= current_file;
						new->hdr.stmt_lno		= (yyvsp[(1) - (6)].ival);

						new->nodes=(yyvsp[(4) - (6)].failed_node_entry);

						(yyval.statement) = (SlonikStmt *)new;
					}
    break;

  case 72:

/* Line 1455 of yacc.c  */
#line 722 "parser.y"
    {
						SlonikStmt_failed_node *new;
						statement_option opt[] = {
							STMT_OPTION_INT( O_ID, -1 ),
							STMT_OPTION_INT( O_BACKUP_NODE, -1 ),
							STMT_OPTION_END
						};

						new = (SlonikStmt_failed_node *)
								malloc(sizeof(SlonikStmt_failed_node));
						memset(new, 0, sizeof(SlonikStmt_failed_node));
						new->hdr.stmt_type		= STMT_FAILED_NODE;
						new->hdr.stmt_filename	= current_file;
						new->hdr.stmt_lno		= (yyvsp[(1) - (3)].ival);
						new->nodes=(failed_node_entry*)
							malloc(sizeof(failed_node_entry)*1);
						memset(new->nodes,0, sizeof(failed_node_entry));

						if (assign_options(opt, (yyvsp[(3) - (3)].opt_list)) == 0)
						{
							new->nodes->no_id			= opt[0].ival;
							new->nodes->backup_node	= opt[1].ival;
						}
						else
							parser_errors++;

						(yyval.statement) = (SlonikStmt *)new;
					}
    break;

  case 73:

/* Line 1455 of yacc.c  */
#line 753 "parser.y"
    {
						failed_node_entry *new;
						statement_option opt[] = {
							STMT_OPTION_INT( O_ID, -1 ),
							STMT_OPTION_INT( O_BACKUP_NODE, -1 ),
							STMT_OPTION_END
						};

						new = (failed_node_entry *)
								malloc(sizeof(failed_node_entry));
						memset(new, 0, sizeof(failed_node_entry));
						if (assign_options(opt, (yyvsp[(4) - (5)].opt_list)) == 0)
						{
							new->no_id			= opt[0].ival;
							new->backup_node	= opt[1].ival;
						}
						else
							parser_errors++;

						(yyval.failed_node_entry) = new;

}
    break;

  case 74:

/* Line 1455 of yacc.c  */
#line 776 "parser.y"
    {
					failed_node_entry *new;
						statement_option opt[] = {
							STMT_OPTION_INT( O_ID, -1 ),
							STMT_OPTION_INT( O_BACKUP_NODE, -1 ),
							STMT_OPTION_END
						};

						new = (failed_node_entry *)
								malloc(sizeof(failed_node_entry));
						memset(new, 0, sizeof(failed_node_entry));
						if (assign_options(opt, (yyvsp[(4) - (7)].opt_list)) == 0)
						{
							new->no_id			= opt[0].ival;
							new->backup_node	= opt[1].ival;
						}
						else
							parser_errors++;
						new->next=(yyvsp[(7) - (7)].failed_node_entry);
						(yyval.failed_node_entry) = new;

}
    break;

  case 75:

/* Line 1455 of yacc.c  */
#line 800 "parser.y"
    {
						SlonikStmt_uninstall_node *new;
						statement_option opt[] = {
							STMT_OPTION_INT( O_ID, -1 ),
							STMT_OPTION_END
						};

						new = (SlonikStmt_uninstall_node *)
								malloc(sizeof(SlonikStmt_uninstall_node));
						memset(new, 0, sizeof(SlonikStmt_uninstall_node));
						new->hdr.stmt_type		= STMT_UNINSTALL_NODE;
						new->hdr.stmt_filename	= current_file;
						new->hdr.stmt_lno		= (yyvsp[(1) - (4)].ival);

						if (assign_options(opt, (yyvsp[(4) - (4)].opt_list)) == 0)
						{
							new->no_id			= opt[0].ival;
						}
						else
							parser_errors++;

						(yyval.statement) = (SlonikStmt *)new;
					}
    break;

  case 76:

/* Line 1455 of yacc.c  */
#line 826 "parser.y"
    {
						SlonikStmt_clone_prepare *new;
						statement_option opt[] = {
							STMT_OPTION_INT( O_ID, -1 ),
							STMT_OPTION_INT( O_PROVIDER, -1 ),
							STMT_OPTION_STR( O_COMMENT, NULL ),
							STMT_OPTION_END
						};

						new = (SlonikStmt_clone_prepare *)
								malloc(sizeof(SlonikStmt_clone_prepare));
						memset(new, 0, sizeof(SlonikStmt_clone_prepare));
						new->hdr.stmt_type		= STMT_CLONE_PREPARE;
						new->hdr.stmt_filename	= current_file;
						new->hdr.stmt_lno		= (yyvsp[(1) - (4)].ival);

						if (assign_options(opt, (yyvsp[(4) - (4)].opt_list)) == 0)
						{
							new->no_id			= opt[0].ival;
							new->no_provider	= opt[1].ival;
							new->no_comment		= opt[2].str;
						}
						else
							parser_errors++;

						(yyval.statement) = (SlonikStmt *)new;
					}
    break;

  case 77:

/* Line 1455 of yacc.c  */
#line 856 "parser.y"
    {
						SlonikStmt_clone_finish *new;
						statement_option opt[] = {
							STMT_OPTION_INT( O_ID, -1 ),
							STMT_OPTION_INT( O_PROVIDER, -1 ),
							STMT_OPTION_END
						};

						new = (SlonikStmt_clone_finish *)
								malloc(sizeof(SlonikStmt_clone_finish));
						memset(new, 0, sizeof(SlonikStmt_clone_finish));
						new->hdr.stmt_type		= STMT_CLONE_FINISH;
						new->hdr.stmt_filename	= current_file;
						new->hdr.stmt_lno		= (yyvsp[(1) - (4)].ival);

						if (assign_options(opt, (yyvsp[(4) - (4)].opt_list)) == 0)
						{
							new->no_id			= opt[0].ival;
							new->no_provider	= opt[1].ival;
						}
						else
							parser_errors++;

						(yyval.statement) = (SlonikStmt *)new;
					}
    break;

  case 78:

/* Line 1455 of yacc.c  */
#line 884 "parser.y"
    {
						SlonikStmt_store_path *new;
						statement_option opt[] = {
							STMT_OPTION_INT( O_SERVER, -1 ),
							STMT_OPTION_INT( O_CLIENT, -1 ),
							STMT_OPTION_STR( O_CONNINFO, NULL ),
							STMT_OPTION_INT( O_CONNRETRY, 10 ),
							STMT_OPTION_END
						};

						new = (SlonikStmt_store_path *)
								malloc(sizeof(SlonikStmt_store_path));
						memset(new, 0, sizeof(SlonikStmt_store_path));
						new->hdr.stmt_type		= STMT_STORE_PATH;
						new->hdr.stmt_filename	= current_file;
						new->hdr.stmt_lno		= (yyvsp[(1) - (4)].ival);

						if (assign_options(opt, (yyvsp[(4) - (4)].opt_list)) == 0)
						{
							new->pa_server		= opt[0].ival;
							new->pa_client		= opt[1].ival;
							new->pa_conninfo	= opt[2].str;
							new->pa_connretry	= opt[3].ival;
						}
						else
							parser_errors++;

						(yyval.statement) = (SlonikStmt *)new;
					}
    break;

  case 79:

/* Line 1455 of yacc.c  */
#line 916 "parser.y"
    {
						SlonikStmt_drop_path *new;
						statement_option opt[] = {
							STMT_OPTION_INT( O_SERVER, -1 ),
							STMT_OPTION_INT( O_CLIENT, -1 ),
							STMT_OPTION_INT( O_EVENT_NODE, -1 ),
							STMT_OPTION_END
						};

						new = (SlonikStmt_drop_path *)
								malloc(sizeof(SlonikStmt_drop_path));
						memset(new, 0, sizeof(SlonikStmt_drop_path));
						new->hdr.stmt_type		= STMT_DROP_PATH;
						new->hdr.stmt_filename	= current_file;
						new->hdr.stmt_lno		= (yyvsp[(1) - (4)].ival);

						if (assign_options(opt, (yyvsp[(4) - (4)].opt_list)) == 0)
						{
							new->pa_server		= opt[0].ival;
							new->pa_client		= opt[1].ival;
							new->ev_origin		= opt[2].ival;
						}
						else
							parser_errors++;

						(yyval.statement) = (SlonikStmt *)new;
					}
    break;

  case 80:

/* Line 1455 of yacc.c  */
#line 946 "parser.y"
    {
						SlonikStmt_store_listen *new;
						statement_option opt[] = {
							STMT_OPTION_INT( O_ORIGIN, -1 ),
							STMT_OPTION_INT( O_RECEIVER, -1 ),
							STMT_OPTION_INT( O_PROVIDER, -1 ),
							STMT_OPTION_END
						};

						new = (SlonikStmt_store_listen *)
								malloc(sizeof(SlonikStmt_store_listen));
						memset(new, 0, sizeof(SlonikStmt_store_listen));
						new->hdr.stmt_type		= STMT_STORE_LISTEN;
						new->hdr.stmt_filename	= current_file;
						new->hdr.stmt_lno		= (yyvsp[(1) - (4)].ival);

						if (assign_options(opt, (yyvsp[(4) - (4)].opt_list)) == 0)
						{
							new->li_origin		= opt[0].ival;
							new->li_receiver	= opt[1].ival;
							new->li_provider	= opt[2].ival;
						}
						else
							parser_errors++;

						(yyval.statement) = (SlonikStmt *)new;
					}
    break;

  case 81:

/* Line 1455 of yacc.c  */
#line 976 "parser.y"
    {
						SlonikStmt_drop_listen *new;
						statement_option opt[] = {
							STMT_OPTION_INT( O_ORIGIN, -1 ),
							STMT_OPTION_INT( O_RECEIVER, -1 ),
							STMT_OPTION_INT( O_PROVIDER, -1 ),
							STMT_OPTION_END
						};

						new = (SlonikStmt_drop_listen *)
								malloc(sizeof(SlonikStmt_drop_listen));
						memset(new, 0, sizeof(SlonikStmt_drop_listen));
						new->hdr.stmt_type		= STMT_DROP_LISTEN;
						new->hdr.stmt_filename	= current_file;
						new->hdr.stmt_lno		= (yyvsp[(1) - (4)].ival);

						if (assign_options(opt, (yyvsp[(4) - (4)].opt_list)) == 0)
						{
							new->li_origin		= opt[0].ival;
							new->li_receiver	= opt[1].ival;
							new->li_provider	= opt[2].ival;
						}
						else
							parser_errors++;

						(yyval.statement) = (SlonikStmt *)new;
					}
    break;

  case 82:

/* Line 1455 of yacc.c  */
#line 1006 "parser.y"
    {
						SlonikStmt_create_set *new;
						statement_option opt[] = {
							STMT_OPTION_INT( O_ID, -1 ),
							STMT_OPTION_INT( O_ORIGIN, -1 ),
							STMT_OPTION_STR( O_COMMENT, NULL ),
							STMT_OPTION_END
						};

						new = (SlonikStmt_create_set *)
								malloc(sizeof(SlonikStmt_create_set));
						memset(new, 0, sizeof(SlonikStmt_create_set));
						new->hdr.stmt_type		= STMT_CREATE_SET;
						new->hdr.stmt_filename	= current_file;
						new->hdr.stmt_lno		= (yyvsp[(1) - (4)].ival);

						if (assign_options(opt, (yyvsp[(4) - (4)].opt_list)) == 0)
						{
							new->set_id			= opt[0].ival;
							new->set_origin		= opt[1].ival;
							new->set_comment	= opt[2].str;
						}
						else
							parser_errors++;

						(yyval.statement) = (SlonikStmt *)new;
					}
    break;

  case 83:

/* Line 1455 of yacc.c  */
#line 1036 "parser.y"
    {
						SlonikStmt_drop_set *new;
						statement_option opt[] = {
							STMT_OPTION_INT( O_ID, -1 ),
							STMT_OPTION_INT( O_ORIGIN, -1 ),
							STMT_OPTION_END
						};

						new = (SlonikStmt_drop_set *)
								malloc(sizeof(SlonikStmt_drop_set));
						memset(new, 0, sizeof(SlonikStmt_drop_set));
						new->hdr.stmt_type		= STMT_DROP_SET;
						new->hdr.stmt_filename	= current_file;
						new->hdr.stmt_lno		= (yyvsp[(1) - (4)].ival);

						if (assign_options(opt, (yyvsp[(4) - (4)].opt_list)) == 0)
						{
							new->set_id			= opt[0].ival;
							new->set_origin		= opt[1].ival;
						}
						else
							parser_errors++;

						(yyval.statement) = (SlonikStmt *)new;
					}
    break;

  case 84:

/* Line 1455 of yacc.c  */
#line 1064 "parser.y"
    {
						SlonikStmt_merge_set *new;
						statement_option opt[] = {
							STMT_OPTION_INT( O_ID, -1 ),
							STMT_OPTION_INT( O_ADD_ID, -1 ),
							STMT_OPTION_INT( O_ORIGIN, -1 ),
							STMT_OPTION_END
						};

						new = (SlonikStmt_merge_set *)
								malloc(sizeof(SlonikStmt_merge_set));
						memset(new, 0, sizeof(SlonikStmt_merge_set));
						new->hdr.stmt_type		= STMT_MERGE_SET;
						new->hdr.stmt_filename	= current_file;
						new->hdr.stmt_lno		= (yyvsp[(1) - (4)].ival);

						if (assign_options(opt, (yyvsp[(4) - (4)].opt_list)) == 0)
						{
							new->set_id			= opt[0].ival;
							new->add_id			= opt[1].ival;
							new->set_origin		= opt[2].ival;
						}
						else
							parser_errors++;

						(yyval.statement) = (SlonikStmt *)new;
					}
    break;

  case 85:

/* Line 1455 of yacc.c  */
#line 1095 "parser.y"
    {
						SlonikStmt_set_add_table *new;
						statement_option opt[] = {
							STMT_OPTION_INT( O_SET_ID, -1 ),
							STMT_OPTION_INT( O_ORIGIN, -1 ),
							STMT_OPTION_INT( O_ID, -1 ),
							STMT_OPTION_STR( O_FQNAME, NULL ),
							STMT_OPTION_STR( O_USE_KEY, NULL ),
							STMT_OPTION_STR( O_COMMENT, NULL ),
							STMT_OPTION_STR( O_TABLES,NULL),
							STMT_OPTION_YN(O_ADD_SEQUENCES,0),
							STMT_OPTION_END
						};

						new = (SlonikStmt_set_add_table *)
								malloc(sizeof(SlonikStmt_set_add_table));
						memset(new, 0, sizeof(SlonikStmt_set_add_table));
						new->hdr.stmt_type		= STMT_SET_ADD_TABLE;
						new->hdr.stmt_filename	= current_file;
						new->hdr.stmt_lno		= (yyvsp[(1) - (5)].ival);

						if (assign_options(opt, (yyvsp[(5) - (5)].opt_list)) == 0)
						{
							new->set_id			= opt[0].ival;
							new->set_origin		= opt[1].ival;
							new->tab_id			= opt[2].ival;
							new->tab_fqname		= opt[3].str;
							new->use_key		= opt[4].str;
							new->tab_comment	= opt[5].str;
							new->tables			= opt[6].str;
							new->add_sequences  = opt[7].ival;
						}
						else
							parser_errors++;

						(yyval.statement) = (SlonikStmt *)new;
					}
    break;

  case 86:

/* Line 1455 of yacc.c  */
#line 1135 "parser.y"
    {
						SlonikStmt_set_add_sequence *new;
						statement_option opt[] = {
							STMT_OPTION_INT( O_SET_ID, -1 ),
							STMT_OPTION_INT( O_ORIGIN, -1 ),
							STMT_OPTION_INT( O_ID, -1 ),
							STMT_OPTION_STR( O_FQNAME, NULL ),
							STMT_OPTION_STR( O_COMMENT, NULL ),
							STMT_OPTION_STR( O_SEQUENCES, NULL),
							STMT_OPTION_END
						};

						new = (SlonikStmt_set_add_sequence *)
								malloc(sizeof(SlonikStmt_set_add_sequence));
						memset(new, 0, sizeof(SlonikStmt_set_add_sequence));
						new->hdr.stmt_type		= STMT_SET_ADD_SEQUENCE;
						new->hdr.stmt_filename	= current_file;
						new->hdr.stmt_lno		= (yyvsp[(1) - (5)].ival);

						if (assign_options(opt, (yyvsp[(5) - (5)].opt_list)) == 0)
						{
							new->set_id			= opt[0].ival;
							new->set_origin		= opt[1].ival;
							new->seq_id			= opt[2].ival;
							new->seq_fqname		= opt[3].str;
							new->seq_comment	= opt[4].str;
							new->sequences		= opt[5].str;
						}
						else
							parser_errors++;

						(yyval.statement) = (SlonikStmt *)new;
					}
    break;

  case 87:

/* Line 1455 of yacc.c  */
#line 1171 "parser.y"
    {
						SlonikStmt_set_drop_table *new;
						statement_option opt[] = {
							STMT_OPTION_INT( O_ORIGIN, -1 ),
							STMT_OPTION_INT( O_ID, -1 ),
							STMT_OPTION_END
						};
						new = (SlonikStmt_set_drop_table *)
							malloc(sizeof(SlonikStmt_set_drop_table));
						memset(new, 0, sizeof(SlonikStmt_set_drop_table));
						new->hdr.stmt_type		= STMT_SET_DROP_TABLE;
						new->hdr.stmt_filename	= current_file;
						new->hdr.stmt_lno		= (yyvsp[(1) - (5)].ival);

						if (assign_options(opt, (yyvsp[(5) - (5)].opt_list)) == 0) {
							new->set_origin		= opt[0].ival;
							new->tab_id			= opt[1].ival;
						}
						else
							parser_errors++;

						(yyval.statement) = (SlonikStmt *)new;
					}
    break;

  case 88:

/* Line 1455 of yacc.c  */
#line 1197 "parser.y"
    {
						SlonikStmt_set_drop_sequence *new;
						statement_option opt[] = {
							STMT_OPTION_INT( O_ORIGIN, -1 ),
							STMT_OPTION_INT( O_ID, -1 ),
							STMT_OPTION_END
						};

						new = (SlonikStmt_set_drop_sequence *)
								malloc(sizeof(SlonikStmt_set_drop_sequence));
						memset(new, 0, sizeof(SlonikStmt_set_drop_sequence));
						new->hdr.stmt_type		= STMT_SET_DROP_SEQUENCE;
						new->hdr.stmt_filename	= current_file;
						new->hdr.stmt_lno		= (yyvsp[(1) - (5)].ival);

						if (assign_options(opt, (yyvsp[(5) - (5)].opt_list)) == 0)
						{
							new->set_origin		= opt[0].ival;
							new->seq_id			= opt[1].ival;
						}
						else
							parser_errors++;

						(yyval.statement) = (SlonikStmt *)new;
					}
    break;

  case 89:

/* Line 1455 of yacc.c  */
#line 1225 "parser.y"
    {
						SlonikStmt_set_move_table *new;
						statement_option opt[] = {
							STMT_OPTION_INT( O_ORIGIN, -1 ),
							STMT_OPTION_INT( O_ID, -1 ),
							STMT_OPTION_INT( O_NEW_SET, -1 ),
							STMT_OPTION_END
						};
						new = (SlonikStmt_set_move_table *)
							malloc(sizeof(SlonikStmt_set_move_table));
						memset(new, 0, sizeof(SlonikStmt_set_move_table));
						new->hdr.stmt_type		= STMT_SET_MOVE_TABLE;
						new->hdr.stmt_filename	= current_file;
						new->hdr.stmt_lno		= (yyvsp[(1) - (5)].ival);

						if (assign_options(opt, (yyvsp[(5) - (5)].opt_list)) == 0) {
							new->set_origin		= opt[0].ival;
							new->tab_id			= opt[1].ival;
							new->new_set_id		= opt[2].ival;
						}
						else
							parser_errors++;

						(yyval.statement) = (SlonikStmt *)new;
					}
    break;

  case 90:

/* Line 1455 of yacc.c  */
#line 1253 "parser.y"
    {
						SlonikStmt_set_move_sequence *new;
						statement_option opt[] = {
							STMT_OPTION_INT( O_ORIGIN, -1 ),
							STMT_OPTION_INT( O_ID, -1 ),
							STMT_OPTION_INT( O_NEW_SET, -1 ),
							STMT_OPTION_END
						};

						new = (SlonikStmt_set_move_sequence *)
								malloc(sizeof(SlonikStmt_set_move_sequence));
						memset(new, 0, sizeof(SlonikStmt_set_move_sequence));
						new->hdr.stmt_type		= STMT_SET_MOVE_SEQUENCE;
						new->hdr.stmt_filename	= current_file;
						new->hdr.stmt_lno		= (yyvsp[(1) - (5)].ival);

						if (assign_options(opt, (yyvsp[(5) - (5)].opt_list)) == 0)
						{
							new->set_origin		= opt[0].ival;
							new->seq_id			= opt[1].ival;
							new->new_set_id		= opt[2].ival;
						}
						else
							parser_errors++;

						(yyval.statement) = (SlonikStmt *)new;
					}
    break;

  case 91:

/* Line 1455 of yacc.c  */
#line 1283 "parser.y"
    {
						SlonikStmt_subscribe_set *new;
						statement_option opt[] = {
							STMT_OPTION_INT( O_ID, -1 ),
							STMT_OPTION_INT( O_PROVIDER, -1 ),
							STMT_OPTION_INT( O_RECEIVER, -1 ),
							STMT_OPTION_YN( O_FORWARD, 0 ),
							STMT_OPTION_YN( O_OMIT_COPY, 0 ),
							STMT_OPTION_END
						};

						new = (SlonikStmt_subscribe_set *)
								malloc(sizeof(SlonikStmt_subscribe_set));
						memset(new, 0, sizeof(SlonikStmt_subscribe_set));
						new->hdr.stmt_type		= STMT_SUBSCRIBE_SET;
						new->hdr.stmt_filename	= current_file;
						new->hdr.stmt_lno		= (yyvsp[(1) - (4)].ival);

						if (assign_options(opt, (yyvsp[(4) - (4)].opt_list)) == 0)
						{
							new->sub_setid		= opt[0].ival;
							new->sub_provider	= opt[1].ival;
							new->sub_receiver	= opt[2].ival;
							new->sub_forward	= opt[3].ival;
							new->omit_copy      = opt[4].ival;
						}
						else
							parser_errors++;

						(yyval.statement) = (SlonikStmt *)new;
					}
    break;

  case 92:

/* Line 1455 of yacc.c  */
#line 1316 "parser.y"
    {
						SlonikStmt_unsubscribe_set *new;
						statement_option opt[] = {
							STMT_OPTION_INT( O_ID, -1 ),
							STMT_OPTION_INT( O_RECEIVER, -1 ),
							STMT_OPTION_END
						};

						new = (SlonikStmt_unsubscribe_set *)
								malloc(sizeof(SlonikStmt_unsubscribe_set));
						memset(new, 0, sizeof(SlonikStmt_unsubscribe_set));
						new->hdr.stmt_type		= STMT_UNSUBSCRIBE_SET;
						new->hdr.stmt_filename	= current_file;
						new->hdr.stmt_lno		= (yyvsp[(1) - (4)].ival);

						if (assign_options(opt, (yyvsp[(4) - (4)].opt_list)) == 0)
						{
							new->sub_setid		= opt[0].ival;
							new->sub_receiver	= opt[1].ival;
						}
						else
							parser_errors++;

						(yyval.statement) = (SlonikStmt *)new;
					}
    break;

  case 93:

/* Line 1455 of yacc.c  */
#line 1344 "parser.y"
    {
						SlonikStmt_lock_set *new;
						statement_option opt[] = {
							STMT_OPTION_INT( O_ID, -1 ),
							STMT_OPTION_INT( O_ORIGIN, -1 ),
							STMT_OPTION_END
						};

						new = (SlonikStmt_lock_set *)
								malloc(sizeof(SlonikStmt_lock_set));
						memset(new, 0, sizeof(SlonikStmt_lock_set));
						new->hdr.stmt_type		= STMT_LOCK_SET;
						new->hdr.stmt_filename	= current_file;
						new->hdr.stmt_lno		= (yyvsp[(1) - (4)].ival);

						if (assign_options(opt, (yyvsp[(4) - (4)].opt_list)) == 0)
						{
							new->set_id			= opt[0].ival;
							new->set_origin		= opt[1].ival;
						}
						else
							parser_errors++;

						(yyval.statement) = (SlonikStmt *)new;
					}
    break;

  case 94:

/* Line 1455 of yacc.c  */
#line 1372 "parser.y"
    {
						SlonikStmt_unlock_set *new;
						statement_option opt[] = {
							STMT_OPTION_INT( O_ID, -1 ),
							STMT_OPTION_INT( O_ORIGIN, -1 ),
							STMT_OPTION_END
						};

						new = (SlonikStmt_unlock_set *)
								malloc(sizeof(SlonikStmt_unlock_set));
						memset(new, 0, sizeof(SlonikStmt_unlock_set));
						new->hdr.stmt_type		= STMT_UNLOCK_SET;
						new->hdr.stmt_filename	= current_file;
						new->hdr.stmt_lno		= (yyvsp[(1) - (4)].ival);

						if (assign_options(opt, (yyvsp[(4) - (4)].opt_list)) == 0)
						{
							new->set_id			= opt[0].ival;
							new->set_origin		= opt[1].ival;
						}
						else
							parser_errors++;

						(yyval.statement) = (SlonikStmt *)new;
					}
    break;

  case 95:

/* Line 1455 of yacc.c  */
#line 1400 "parser.y"
    {
						SlonikStmt_move_set *new;
						statement_option opt[] = {
							STMT_OPTION_INT( O_ID, -1 ),
							STMT_OPTION_INT( O_OLD_ORIGIN, -1 ),
							STMT_OPTION_INT( O_NEW_ORIGIN, -1 ),
							STMT_OPTION_END
						};

						new = (SlonikStmt_move_set *)
								malloc(sizeof(SlonikStmt_move_set));
						memset(new, 0, sizeof(SlonikStmt_move_set));
						new->hdr.stmt_type		= STMT_MOVE_SET;
						new->hdr.stmt_filename	= current_file;
						new->hdr.stmt_lno		= (yyvsp[(1) - (4)].ival);

						if (assign_options(opt, (yyvsp[(4) - (4)].opt_list)) == 0)
						{
							new->set_id			= opt[0].ival;
							new->old_origin		= opt[1].ival;
							new->new_origin		= opt[2].ival;
						}
						else
							parser_errors++;

						(yyval.statement) = (SlonikStmt *)new;
					}
    break;

  case 96:

/* Line 1455 of yacc.c  */
#line 1430 "parser.y"
    {
						SlonikStmt_ddl_script *new;
						statement_option opt[] = {
							STMT_OPTION_STR( O_FILENAME, NULL ),
							STMT_OPTION_INT( O_EVENT_NODE, -1 ),
							STMT_OPTION_STR( O_EXECUTE_ONLY_LIST, NULL ),
							STMT_OPTION_INT( O_EXECUTE_ONLY_ON, -1 ),
							STMT_OPTION_END
						};

						new = (SlonikStmt_ddl_script *)
								malloc(sizeof(SlonikStmt_ddl_script));
						memset(new, 0, sizeof(SlonikStmt_ddl_script));
						new->hdr.stmt_type		= STMT_DDL_SCRIPT;
						new->hdr.stmt_filename	= current_file;
						new->hdr.stmt_lno		= (yyvsp[(1) - (4)].ival);

						if (assign_options(opt, (yyvsp[(4) - (4)].opt_list)) == 0)
						{
							new->ddl_fname		= opt[0].str;
							new->ev_origin		= opt[1].ival;
							new->only_on_nodes	= opt[2].str;
							new->only_on_node   = opt[3].ival;
							new->ddl_fd			= NULL;
						}
						else
							parser_errors++;

						(yyval.statement) = (SlonikStmt *)new;
					}
    break;

  case 97:

/* Line 1455 of yacc.c  */
#line 1463 "parser.y"
    {
						SlonikStmt_update_functions *new;
						statement_option opt[] = {
							STMT_OPTION_INT( O_ID, -1 ),
							STMT_OPTION_END
						};

						new = (SlonikStmt_update_functions *)
								malloc(sizeof(SlonikStmt_update_functions));
						memset(new, 0, sizeof(SlonikStmt_update_functions));
						new->hdr.stmt_type		= STMT_UPDATE_FUNCTIONS;
						new->hdr.stmt_filename	= current_file;
						new->hdr.stmt_lno		= (yyvsp[(1) - (4)].ival);

						if (assign_options(opt, (yyvsp[(4) - (4)].opt_list)) == 0)
						{
							new->no_id			= opt[0].ival;
						}
						else
							parser_errors++;

						(yyval.statement) = (SlonikStmt *)new;
					}
    break;

  case 98:

/* Line 1455 of yacc.c  */
#line 1488 "parser.y"
    {
						SlonikStmt_repair_config *new;
						statement_option opt[] = {
							STMT_OPTION_INT( O_SET_ID, -1 ),
							STMT_OPTION_INT( O_EVENT_NODE, -1 ),
							STMT_OPTION_INT( O_EXECUTE_ONLY_ON, -1 ),
							STMT_OPTION_END
						};

						new = (SlonikStmt_repair_config *)
							malloc(sizeof(SlonikStmt_repair_config));
						memset(new, 0, sizeof(SlonikStmt_repair_config));
                                                new->hdr.stmt_type              = STMT_REPAIR_CONFIG;
                                                new->hdr.stmt_filename  = current_file;
                                                new->hdr.stmt_lno               = (yyvsp[(1) - (4)].ival);

                                                if (assign_options(opt, (yyvsp[(4) - (4)].opt_list)) == 0)
						{
							new->set_id		= opt[0].ival;
							new->ev_origin		= opt[1].ival;
							new->only_on_node	= opt[2].ival;
						}
						else
						{
							parser_errors++;
						}
                                                (yyval.statement) = (SlonikStmt *)new;
                                        }
    break;

  case 99:

/* Line 1455 of yacc.c  */
#line 1519 "parser.y"
    {
						SlonikStmt_wait_event *new;
						statement_option opt[] = {
							STMT_OPTION_INT( O_ORIGIN, -1 ),
							STMT_OPTION_INT( O_WAIT_CONFIRMED, -1 ),
							STMT_OPTION_INT( O_WAIT_ON, -1 ),
							STMT_OPTION_INT( O_TIMEOUT, 600 ),
							STMT_OPTION_END
						};

						new = (SlonikStmt_wait_event *)
								malloc(sizeof(SlonikStmt_wait_event));
						memset(new, 0, sizeof(SlonikStmt_wait_event));
						new->hdr.stmt_type		= STMT_WAIT_EVENT;
						new->hdr.stmt_filename	= current_file;
						new->hdr.stmt_lno		= (yyvsp[(1) - (5)].ival);

						if (assign_options(opt, (yyvsp[(5) - (5)].opt_list)) == 0)
						{
							new->wait_origin	= opt[0].ival;
							new->wait_confirmed	= opt[1].ival;
							new->wait_on		= opt[2].ival;
							new->wait_timeout	= opt[3].ival;
						}
						else
							parser_errors++;

						(yyval.statement) = (SlonikStmt *)new;
					}
    break;

  case 100:

/* Line 1455 of yacc.c  */
#line 1551 "parser.y"
    {
						SlonikStmt_wait_event *new;

						new = (SlonikStmt_wait_event *)
								malloc(sizeof(SlonikStmt_wait_event));
						memset(new, 0, sizeof(SlonikStmt_wait_event));
						new->hdr.stmt_type		= STMT_WAIT_EVENT;
						new->hdr.stmt_filename	= current_file;
						new->hdr.stmt_lno		= (yyvsp[(1) - (5)].ival);

						fprintf(stderr, "%s:%d: wait for event "
								"not allowed inside try block\n",
								current_file, (yyvsp[(1) - (5)].ival));
						parser_errors++;

						(yyval.statement) = (SlonikStmt *)new;
					}
    break;

  case 101:

/* Line 1455 of yacc.c  */
#line 1571 "parser.y"
    {
						SlonikStmt_switch_log *new;
						statement_option opt[] = {
							STMT_OPTION_INT( O_ID, -1 ),
							STMT_OPTION_END
						};

						new = (SlonikStmt_switch_log *)
								malloc(sizeof(SlonikStmt_switch_log));
						memset(new, 0, sizeof(SlonikStmt_switch_log));
						new->hdr.stmt_type		= STMT_SWITCH_LOG;
						new->hdr.stmt_filename	= current_file;
						new->hdr.stmt_lno		= (yyvsp[(1) - (4)].ival);

						if (assign_options(opt, (yyvsp[(4) - (4)].opt_list)) == 0)
						{
							new->no_id			= opt[0].ival;
						}
						else
							parser_errors++;

						(yyval.statement) = (SlonikStmt *)new;
					}
    break;

  case 102:

/* Line 1455 of yacc.c  */
#line 1597 "parser.y"
    {
						SlonikStmt_sync *new;
						statement_option opt[] = {
							STMT_OPTION_INT( O_ID, -1 ),
							STMT_OPTION_END
						};

						new = (SlonikStmt_sync *)
								malloc(sizeof(SlonikStmt_sync));
						memset(new, 0, sizeof(SlonikStmt_sync));
						new->hdr.stmt_type		= STMT_SYNC;
						new->hdr.stmt_filename	= current_file;
						new->hdr.stmt_lno		= (yyvsp[(1) - (3)].ival);

						if (assign_options(opt, (yyvsp[(3) - (3)].opt_list)) == 0)
						{
							new->no_id			= opt[0].ival;
						}
						else
							parser_errors++;

						(yyval.statement) = (SlonikStmt *)new;
					}
    break;

  case 103:

/* Line 1455 of yacc.c  */
#line 1623 "parser.y"
    {
						SlonikStmt_sleep *new;
						statement_option opt[] = {
							STMT_OPTION_INT( O_SECONDS, -1 ),
							STMT_OPTION_END
						};

						new = (SlonikStmt_sleep *)
								malloc(sizeof(SlonikStmt_sleep));
						memset(new, 0, sizeof(SlonikStmt_sleep));
						new->hdr.stmt_type		= STMT_SLEEP;
						new->hdr.stmt_filename	= current_file;
						new->hdr.stmt_lno		= (yyvsp[(1) - (3)].ival);

						if (assign_options(opt, (yyvsp[(3) - (3)].opt_list)) == 0)
						{
							new->num_secs			= opt[0].ival;
						}
						else
							parser_errors++;

						(yyval.statement) = (SlonikStmt *)new;
					}
    break;

  case 104:

/* Line 1455 of yacc.c  */
#line 1649 "parser.y"
    { (yyval.opt_list) = NULL; }
    break;

  case 105:

/* Line 1455 of yacc.c  */
#line 1651 "parser.y"
    { (yyval.opt_list) = (yyvsp[(2) - (4)].opt_list); }
    break;

  case 106:

/* Line 1455 of yacc.c  */
#line 1655 "parser.y"
    { (yyval.opt_list) = (yyvsp[(1) - (1)].opt_list); }
    break;

  case 107:

/* Line 1455 of yacc.c  */
#line 1657 "parser.y"
    { (yyvsp[(1) - (3)].opt_list)->next = (yyvsp[(3) - (3)].opt_list); (yyval.opt_list) = (yyvsp[(1) - (3)].opt_list); }
    break;

  case 108:

/* Line 1455 of yacc.c  */
#line 1661 "parser.y"
    {
						(yyvsp[(3) - (3)].opt_list)->opt_code	= O_ID;
						(yyval.opt_list) = (yyvsp[(3) - (3)].opt_list);
					}
    break;

  case 109:

/* Line 1455 of yacc.c  */
#line 1666 "parser.y"
    {
						(yyvsp[(3) - (3)].opt_list)->opt_code= O_ID;
						(yyval.opt_list)=(yyvsp[(3) - (3)].opt_list);
					}
    break;

  case 110:

/* Line 1455 of yacc.c  */
#line 1671 "parser.y"
    {
						(yyvsp[(4) - (4)].opt_list)->opt_code	= O_BACKUP_NODE;
						(yyval.opt_list) = (yyvsp[(4) - (4)].opt_list);
					}
    break;

  case 111:

/* Line 1455 of yacc.c  */
#line 1676 "parser.y"
    {
						(yyvsp[(4) - (4)].opt_list)->opt_code	= O_EVENT_NODE;
						(yyval.opt_list) = (yyvsp[(4) - (4)].opt_list);
					}
    break;

  case 112:

/* Line 1455 of yacc.c  */
#line 1681 "parser.y"
    {
						(yyvsp[(3) - (3)].opt_list)->opt_code	= O_SERVER;
						(yyval.opt_list) = (yyvsp[(3) - (3)].opt_list);
					}
    break;

  case 113:

/* Line 1455 of yacc.c  */
#line 1686 "parser.y"
    {
						(yyvsp[(3) - (3)].opt_list)->opt_code	= O_CLIENT;
						(yyval.opt_list) = (yyvsp[(3) - (3)].opt_list);
					}
    break;

  case 114:

/* Line 1455 of yacc.c  */
#line 1691 "parser.y"
    {
						(yyvsp[(3) - (3)].opt_list)->opt_code	= O_ORIGIN;
						(yyval.opt_list) = (yyvsp[(3) - (3)].opt_list);
					}
    break;

  case 115:

/* Line 1455 of yacc.c  */
#line 1696 "parser.y"
    {
						(yyvsp[(4) - (4)].opt_list)->opt_code	= O_OLD_ORIGIN;
						(yyval.opt_list) = (yyvsp[(4) - (4)].opt_list);
					}
    break;

  case 116:

/* Line 1455 of yacc.c  */
#line 1701 "parser.y"
    {
						(yyvsp[(4) - (4)].opt_list)->opt_code	= O_OMIT_COPY;
						(yyval.opt_list) = (yyvsp[(4) - (4)].opt_list);
					}
    break;

  case 117:

/* Line 1455 of yacc.c  */
#line 1706 "parser.y"
    {
						(yyvsp[(4) - (4)].opt_list)->opt_code	= O_NEW_ORIGIN;
						(yyval.opt_list) = (yyvsp[(4) - (4)].opt_list);
					}
    break;

  case 118:

/* Line 1455 of yacc.c  */
#line 1711 "parser.y"
    {
						(yyvsp[(4) - (4)].opt_list)->opt_code	= O_NEW_SET;
						(yyval.opt_list) = (yyvsp[(4) - (4)].opt_list);
					}
    break;

  case 119:

/* Line 1455 of yacc.c  */
#line 1716 "parser.y"
    {
						(yyvsp[(3) - (3)].opt_list)->opt_code	= O_RECEIVER;
						(yyval.opt_list) = (yyvsp[(3) - (3)].opt_list);
					}
    break;

  case 120:

/* Line 1455 of yacc.c  */
#line 1721 "parser.y"
    {
						(yyvsp[(3) - (3)].opt_list)->opt_code	= O_PROVIDER;
						(yyval.opt_list) = (yyvsp[(3) - (3)].opt_list);
					}
    break;

  case 121:

/* Line 1455 of yacc.c  */
#line 1726 "parser.y"
    {
						(yyvsp[(3) - (3)].opt_list)->opt_code	= O_CONNRETRY;
						(yyval.opt_list) = (yyvsp[(3) - (3)].opt_list);
					}
    break;

  case 122:

/* Line 1455 of yacc.c  */
#line 1731 "parser.y"
    {
						(yyvsp[(3) - (3)].opt_list)->opt_code	= O_COMMENT;
						(yyval.opt_list) = (yyvsp[(3) - (3)].opt_list);
					}
    break;

  case 123:

/* Line 1455 of yacc.c  */
#line 1736 "parser.y"
    {
						(yyvsp[(3) - (3)].opt_list)->opt_code	= O_CONNINFO;
						(yyval.opt_list) = (yyvsp[(3) - (3)].opt_list);
					}
    break;

  case 124:

/* Line 1455 of yacc.c  */
#line 1741 "parser.y"
    {
						(yyvsp[(3) - (3)].opt_list)->opt_code	= O_DATE_FORMAT;
						(yyval.opt_list) = (yyvsp[(3) - (3)].opt_list);
					}
    break;

  case 125:

/* Line 1455 of yacc.c  */
#line 1746 "parser.y"
    {
						(yyvsp[(4) - (4)].opt_list)->opt_code	= O_SET_ID;
						(yyval.opt_list) = (yyvsp[(4) - (4)].opt_list);
					}
    break;

  case 126:

/* Line 1455 of yacc.c  */
#line 1751 "parser.y"
    {
						(yyvsp[(4) - (4)].opt_list)->opt_code	= O_ADD_ID;
						(yyval.opt_list) = (yyvsp[(4) - (4)].opt_list);
					}
    break;

  case 127:

/* Line 1455 of yacc.c  */
#line 1756 "parser.y"
    {
						(yyvsp[(4) - (4)].opt_list)->opt_code	= O_NODE_ID;
						(yyval.opt_list) = (yyvsp[(4) - (4)].opt_list);
					}
    break;

  case 128:

/* Line 1455 of yacc.c  */
#line 1761 "parser.y"
    {
						(yyvsp[(4) - (4)].opt_list)->opt_code	= O_TAB_ID;
						(yyval.opt_list) = (yyvsp[(4) - (4)].opt_list);
					}
    break;

  case 129:

/* Line 1455 of yacc.c  */
#line 1766 "parser.y"
    {
						(yyvsp[(5) - (5)].opt_list)->opt_code	= O_FQNAME;
						(yyval.opt_list) = (yyvsp[(5) - (5)].opt_list);
					}
    break;

  case 130:

/* Line 1455 of yacc.c  */
#line 1771 "parser.y"
    {
						(yyvsp[(3) - (3)].opt_list)->opt_code	= O_USE_KEY;
						(yyval.opt_list) = (yyvsp[(3) - (3)].opt_list);
					}
    break;

  case 131:

/* Line 1455 of yacc.c  */
#line 1776 "parser.y"
    {
						(yyvsp[(3) - (3)].opt_list)->opt_code	= O_FORWARD;
						(yyval.opt_list) = (yyvsp[(3) - (3)].opt_list);
					}
    break;

  case 132:

/* Line 1455 of yacc.c  */
#line 1781 "parser.y"
    {
						(yyvsp[(3) - (3)].opt_list)->opt_code	= O_FILENAME;
						(yyval.opt_list) = (yyvsp[(3) - (3)].opt_list);
					}
    break;

  case 133:

/* Line 1455 of yacc.c  */
#line 1786 "parser.y"
    {
						option_list *new;
						new = (option_list *)malloc(sizeof(option_list));

						new->opt_code	= O_ORIGIN;
						new->ival	= -2;
						new->str	= NULL;
						new->lineno	= yylineno;
						new->next	= NULL;

						(yyval.opt_list) = new;
					}
    break;

  case 134:

/* Line 1455 of yacc.c  */
#line 1799 "parser.y"
    {
						(yyvsp[(3) - (3)].opt_list)->opt_code	= O_WAIT_CONFIRMED;
						(yyval.opt_list) = (yyvsp[(3) - (3)].opt_list);
					}
    break;

  case 135:

/* Line 1455 of yacc.c  */
#line 1804 "parser.y"
    {
						option_list *new;
						new = (option_list *)malloc(sizeof(option_list));

						new->opt_code	= O_WAIT_CONFIRMED;
						new->ival	= -2;
						new->str	= NULL;
						new->lineno	= yylineno;
						new->next	= NULL;

						(yyval.opt_list) = new;
					}
    break;

  case 136:

/* Line 1455 of yacc.c  */
#line 1817 "parser.y"
    {
						(yyvsp[(4) - (4)].opt_list)->opt_code	= O_WAIT_ON;
						(yyval.opt_list) = (yyvsp[(4) - (4)].opt_list);
					}
    break;

  case 137:

/* Line 1455 of yacc.c  */
#line 1822 "parser.y"
    {
						(yyvsp[(3) - (3)].opt_list)->opt_code	= O_TIMEOUT;
						(yyval.opt_list) = (yyvsp[(3) - (3)].opt_list);
					}
    break;

  case 138:

/* Line 1455 of yacc.c  */
#line 1827 "parser.y"
    {
						(yyvsp[(5) - (5)].opt_list)->opt_code	= O_EXECUTE_ONLY_ON;
						(yyval.opt_list) = (yyvsp[(5) - (5)].opt_list);
					}
    break;

  case 139:

/* Line 1455 of yacc.c  */
#line 1832 "parser.y"
    {
						(yyvsp[(5) - (5)].opt_list)->opt_code	= O_EXECUTE_ONLY_LIST;
						(yyval.opt_list) = (yyvsp[(5) - (5)].opt_list);
					}
    break;

  case 140:

/* Line 1455 of yacc.c  */
#line 1837 "parser.y"
    {
						(yyvsp[(3) - (3)].opt_list)->opt_code	= O_SECONDS;
						(yyval.opt_list) = (yyvsp[(3) - (3)].opt_list);
					}
    break;

  case 141:

/* Line 1455 of yacc.c  */
#line 1843 "parser.y"
    {
						(yyvsp[(3) - (3)].opt_list)->opt_code	= O_TABLES;
						(yyval.opt_list) = (yyvsp[(3) - (3)].opt_list);
					}
    break;

  case 142:

/* Line 1455 of yacc.c  */
#line 1848 "parser.y"
    {
						(yyvsp[(3) - (3)].opt_list)->opt_code = O_SEQUENCES;
						(yyval.opt_list) = (yyvsp[(3) - (3)].opt_list);
					}
    break;

  case 143:

/* Line 1455 of yacc.c  */
#line 1853 "parser.y"
    {
						(yyvsp[(4) - (4)].opt_list)->opt_code=O_ADD_SEQUENCES;
						(yyval.opt_list)=(yyvsp[(4) - (4)].opt_list);

					}
    break;

  case 144:

/* Line 1455 of yacc.c  */
#line 1861 "parser.y"
    {
						option_list *new;
						new = (option_list *)malloc(sizeof(option_list));

						new->ival	= (yyvsp[(1) - (1)].ival);
						new->str	= NULL;
						new->lineno	= yylineno;
						new->next	= NULL;

						(yyval.opt_list) = new;
					}
    break;

  case 145:

/* Line 1455 of yacc.c  */
#line 1875 "parser.y"
    {
						option_list *new;
						new = (option_list *)malloc(sizeof(option_list));

						new->ival	= -1;
						new->str	= (yyvsp[(1) - (1)].str);
						new->lineno	= yylineno;
						new->next	= NULL;

						(yyval.opt_list) = new;
					}
    break;

  case 146:

/* Line 1455 of yacc.c  */
#line 1889 "parser.y"
    {
						option_list *new;
						new = (option_list *)malloc(sizeof(option_list));

						new->ival	= 1;
						new->str	= NULL;
						new->lineno	= yylineno;
						new->next	= NULL;

						(yyval.opt_list) = new;
					}
    break;

  case 147:

/* Line 1455 of yacc.c  */
#line 1901 "parser.y"
    {
						option_list *new;
						new = (option_list *)malloc(sizeof(option_list));

						new->ival	= 0;
						new->str	= NULL;
						new->lineno	= yylineno;
						new->next	= NULL;

						(yyval.opt_list) = new;
					}
    break;

  case 154:

/* Line 1455 of yacc.c  */
#line 1925 "parser.y"
    {
						(yyval.ival) = strtol(yytext, NULL, 10);
					}
    break;

  case 155:

/* Line 1455 of yacc.c  */
#line 1931 "parser.y"
    {
						char   *ret;
						size_t toklen=yyget_leng();
						ret = malloc(yyget_leng() + 1);
						memcpy(ret, yytext, toklen);
						ret[toklen] = '\0';

						(yyval.str) = ret;
					}
    break;

  case 156:

/* Line 1455 of yacc.c  */
#line 1943 "parser.y"
    {
						char   *ret;
						size_t toklen=yyget_leng();
						ret = malloc(toklen + 1);
						memcpy(ret, yytext, toklen);
						ret[toklen] = '\0';

						(yyval.str) = ret;
					}
    break;

  case 157:

/* Line 1455 of yacc.c  */
#line 1955 "parser.y"
    { (yyval.ival) = yylineno; }
    break;



/* Line 1455 of yacc.c  */
#line 4248 "y.tab.c"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (yymsg);
	  }
	else
	  {
	    yyerror (YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



/* Line 1675 of yacc.c  */
#line 1958 "parser.y"



/* ----------
 * option_str
 *
 *	Returns a string representation of a common option type
 * ----------
 */
static char *
option_str(option_code opt_code)
{
	switch (opt_code)
	{
		case O_ADD_ID:			return "add id";
		case O_ADD_SEQUENCES:	return "add sequences"; 
		case O_BACKUP_NODE:		return "backup node";
		case O_CLIENT:			return "client";
		case O_COMMENT:			return "comment";
		case O_CONNINFO:		return "conninfo";
		case O_CONNRETRY:		return "connretry";
		case O_DATE_FORMAT:		return "format";
		case O_EVENT_NODE:		return "event node";
		case O_EXECUTE_ONLY_ON:	return "execute only on";
		case O_EXECUTE_ONLY_LIST:	return "execute only on";
		case O_FILENAME:		return "filename";
		case O_FORWARD:			return "forward";
		case O_FQNAME:			return "full qualified name";
		case O_ID:				return "id";
		case O_NEW_ORIGIN:		return "new origin";
		case O_NEW_SET:			return "new set";
		case O_NODE_ID:			return "node id";
		case O_OLD_ORIGIN:		return "old origin";
		case O_OMIT_COPY:       return "omit copy";
		case O_ORIGIN:			return "origin";
		case O_PROVIDER:		return "provider";
		case O_RECEIVER:		return "receiver";
		case O_SECONDS:			return "seconds";
		case O_SEQUENCES:		return "sequences";
		case O_SERVER:			return "server";
		case O_SET_ID:			return "set id";
		case O_TAB_ID:			return "table id";
		case O_TABLES:			return "tables";			
		case O_TIMEOUT:			return "timeout";
		case O_USE_KEY:			return "key";
		case O_WAIT_CONFIRMED:	return "confirmed";
		case O_WAIT_ON:			return "wait on";
		case END_OF_OPTIONS:	return "???";
	}
	return "???";
}

/* ----------
 * assign_options
 *
 *	Try to map the actually given options to the statements specific
 *	possible options.
 * ----------
 */
static int
assign_options(statement_option *so, option_list *ol)
{
	statement_option	   *s_opt;
	option_list			   *u_opt;
	int						errors = 0;

	for (u_opt = ol; u_opt; u_opt = u_opt->next)
	{
		for (s_opt = so; s_opt->opt_code >= 0; s_opt++)
		{
			if (s_opt->opt_code == u_opt->opt_code)
				break;
		}

		if (s_opt->opt_code < 0)
		{
			fprintf(stderr, "%s:%d: option %s not allowed here\n",
					current_file, u_opt->lineno,
					option_str(u_opt->opt_code));
			errors++;
			continue;
		}

		if (s_opt->lineno >= 0)
		{
			fprintf(stderr, "%s:%d: option %s already defined on line %d\n",
					current_file, u_opt->lineno,
					option_str(u_opt->opt_code), s_opt->lineno);
			errors++;
			continue;
		}

		s_opt->lineno	= u_opt->lineno;
		s_opt->ival		= u_opt->ival;
		s_opt->str		= u_opt->str;
	}

	return errors;
}


void
yyerror(const char *msg)
{
	fprintf(stderr, "%s:%d: ERROR: %s at or near %s\n", current_file,
				yylineno, msg, yytext);
	parser_errors++;
}





/*
 * Local Variables:
 *  tab-width: 4
 *  c-indent-level: 4
 *  c-basic-offset: 4
 * End:
 */

